/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __DBUS_GEN_H__
#define __DBUS_GEN_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for org.sessiond.session1.Session */

#define DBUS_TYPE_SESSION (dbus_session_get_type ())
#define DBUS_SESSION(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_SESSION, DBusSession))
#define DBUS_IS_SESSION(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_SESSION))
#define DBUS_SESSION_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), DBUS_TYPE_SESSION, DBusSessionIface))

struct _DBusSession;
typedef struct _DBusSession DBusSession;
typedef struct _DBusSessionIface DBusSessionIface;

struct _DBusSessionIface
{
  GTypeInterface parent_iface;



  gboolean (*handle_inhibit) (
    DBusSession *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_who,
    const gchar *arg_why);

  gboolean (*handle_list_inhibitors) (
    DBusSession *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_lock) (
    DBusSession *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_stop_inhibitors) (
    DBusSession *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_uninhibit) (
    DBusSession *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_id);

  gboolean (*handle_unlock) (
    DBusSession *object,
    GDBusMethodInvocation *invocation);

  const gchar *const * (*get_audio_sinks) (DBusSession *object);

  const gchar *const * (*get_backlights) (DBusSession *object);

  const gchar * (*get_default_audio_sink) (DBusSession *object);

  gboolean  (*get_idle_hint) (DBusSession *object);

  guint64  (*get_idle_since_hint) (DBusSession *object);

  guint64  (*get_idle_since_hint_monotonic) (DBusSession *object);

  gboolean  (*get_inhibited_hint) (DBusSession *object);

  gboolean  (*get_locked_hint) (DBusSession *object);

  const gchar * (*get_version) (DBusSession *object);

  void (*active) (
    DBusSession *object);

  void (*add_audio_sink) (
    DBusSession *object,
    const gchar *arg_path);

  void (*add_backlight) (
    DBusSession *object,
    const gchar *arg_path);

  void (*change_default_audio_sink) (
    DBusSession *object,
    const gchar *arg_path);

  void (*idle) (
    DBusSession *object);

  void (*inactive) (
    DBusSession *object,
    guint arg_seconds);

  void (*lock) (
    DBusSession *object);

  void (*prepare_for_shutdown) (
    DBusSession *object,
    gboolean arg_state);

  void (*prepare_for_sleep) (
    DBusSession *object,
    gboolean arg_state);

  void (*remove_audio_sink) (
    DBusSession *object,
    const gchar *arg_path);

  void (*remove_backlight) (
    DBusSession *object,
    const gchar *arg_path);

  void (*unlock) (
    DBusSession *object);

};

GType dbus_session_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *dbus_session_interface_info (void);
guint dbus_session_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void dbus_session_complete_lock (
    DBusSession *object,
    GDBusMethodInvocation *invocation);

void dbus_session_complete_unlock (
    DBusSession *object,
    GDBusMethodInvocation *invocation);

void dbus_session_complete_inhibit (
    DBusSession *object,
    GDBusMethodInvocation *invocation,
    const gchar *id);

void dbus_session_complete_uninhibit (
    DBusSession *object,
    GDBusMethodInvocation *invocation);

void dbus_session_complete_stop_inhibitors (
    DBusSession *object,
    GDBusMethodInvocation *invocation,
    guint count);

void dbus_session_complete_list_inhibitors (
    DBusSession *object,
    GDBusMethodInvocation *invocation,
    GVariant *inhibitors);



/* D-Bus signal emissions functions: */
void dbus_session_emit_lock (
    DBusSession *object);

void dbus_session_emit_unlock (
    DBusSession *object);

void dbus_session_emit_idle (
    DBusSession *object);

void dbus_session_emit_active (
    DBusSession *object);

void dbus_session_emit_inactive (
    DBusSession *object,
    guint arg_seconds);

void dbus_session_emit_prepare_for_sleep (
    DBusSession *object,
    gboolean arg_state);

void dbus_session_emit_prepare_for_shutdown (
    DBusSession *object,
    gboolean arg_state);

void dbus_session_emit_add_backlight (
    DBusSession *object,
    const gchar *arg_path);

void dbus_session_emit_remove_backlight (
    DBusSession *object,
    const gchar *arg_path);

void dbus_session_emit_add_audio_sink (
    DBusSession *object,
    const gchar *arg_path);

void dbus_session_emit_remove_audio_sink (
    DBusSession *object,
    const gchar *arg_path);

void dbus_session_emit_change_default_audio_sink (
    DBusSession *object,
    const gchar *arg_path);



/* D-Bus method calls: */
void dbus_session_call_lock (
    DBusSession *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_session_call_lock_finish (
    DBusSession *proxy,
    GAsyncResult *res,
    GError **error);

gboolean dbus_session_call_lock_sync (
    DBusSession *proxy,
    GCancellable *cancellable,
    GError **error);

void dbus_session_call_unlock (
    DBusSession *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_session_call_unlock_finish (
    DBusSession *proxy,
    GAsyncResult *res,
    GError **error);

gboolean dbus_session_call_unlock_sync (
    DBusSession *proxy,
    GCancellable *cancellable,
    GError **error);

void dbus_session_call_inhibit (
    DBusSession *proxy,
    const gchar *arg_who,
    const gchar *arg_why,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_session_call_inhibit_finish (
    DBusSession *proxy,
    gchar **out_id,
    GAsyncResult *res,
    GError **error);

gboolean dbus_session_call_inhibit_sync (
    DBusSession *proxy,
    const gchar *arg_who,
    const gchar *arg_why,
    gchar **out_id,
    GCancellable *cancellable,
    GError **error);

void dbus_session_call_uninhibit (
    DBusSession *proxy,
    const gchar *arg_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_session_call_uninhibit_finish (
    DBusSession *proxy,
    GAsyncResult *res,
    GError **error);

gboolean dbus_session_call_uninhibit_sync (
    DBusSession *proxy,
    const gchar *arg_id,
    GCancellable *cancellable,
    GError **error);

void dbus_session_call_stop_inhibitors (
    DBusSession *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_session_call_stop_inhibitors_finish (
    DBusSession *proxy,
    guint *out_count,
    GAsyncResult *res,
    GError **error);

gboolean dbus_session_call_stop_inhibitors_sync (
    DBusSession *proxy,
    guint *out_count,
    GCancellable *cancellable,
    GError **error);

void dbus_session_call_list_inhibitors (
    DBusSession *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_session_call_list_inhibitors_finish (
    DBusSession *proxy,
    GVariant **out_inhibitors,
    GAsyncResult *res,
    GError **error);

gboolean dbus_session_call_list_inhibitors_sync (
    DBusSession *proxy,
    GVariant **out_inhibitors,
    GCancellable *cancellable,
    GError **error);



/* D-Bus property accessors: */
gboolean dbus_session_get_inhibited_hint (DBusSession *object);
void dbus_session_set_inhibited_hint (DBusSession *object, gboolean value);

gboolean dbus_session_get_locked_hint (DBusSession *object);
void dbus_session_set_locked_hint (DBusSession *object, gboolean value);

gboolean dbus_session_get_idle_hint (DBusSession *object);
void dbus_session_set_idle_hint (DBusSession *object, gboolean value);

guint64 dbus_session_get_idle_since_hint (DBusSession *object);
void dbus_session_set_idle_since_hint (DBusSession *object, guint64 value);

guint64 dbus_session_get_idle_since_hint_monotonic (DBusSession *object);
void dbus_session_set_idle_since_hint_monotonic (DBusSession *object, guint64 value);

const gchar *const *dbus_session_get_backlights (DBusSession *object);
gchar **dbus_session_dup_backlights (DBusSession *object);
void dbus_session_set_backlights (DBusSession *object, const gchar *const *value);

const gchar *const *dbus_session_get_audio_sinks (DBusSession *object);
gchar **dbus_session_dup_audio_sinks (DBusSession *object);
void dbus_session_set_audio_sinks (DBusSession *object, const gchar *const *value);

const gchar *dbus_session_get_default_audio_sink (DBusSession *object);
gchar *dbus_session_dup_default_audio_sink (DBusSession *object);
void dbus_session_set_default_audio_sink (DBusSession *object, const gchar *value);

const gchar *dbus_session_get_version (DBusSession *object);
gchar *dbus_session_dup_version (DBusSession *object);
void dbus_session_set_version (DBusSession *object, const gchar *value);


/* ---- */

#define DBUS_TYPE_SESSION_PROXY (dbus_session_proxy_get_type ())
#define DBUS_SESSION_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_SESSION_PROXY, DBusSessionProxy))
#define DBUS_SESSION_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), DBUS_TYPE_SESSION_PROXY, DBusSessionProxyClass))
#define DBUS_SESSION_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), DBUS_TYPE_SESSION_PROXY, DBusSessionProxyClass))
#define DBUS_IS_SESSION_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_SESSION_PROXY))
#define DBUS_IS_SESSION_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), DBUS_TYPE_SESSION_PROXY))

typedef struct _DBusSessionProxy DBusSessionProxy;
typedef struct _DBusSessionProxyClass DBusSessionProxyClass;
typedef struct _DBusSessionProxyPrivate DBusSessionProxyPrivate;

struct _DBusSessionProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  DBusSessionProxyPrivate *priv;
};

struct _DBusSessionProxyClass
{
  GDBusProxyClass parent_class;
};

GType dbus_session_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DBusSessionProxy, g_object_unref)
#endif

void dbus_session_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
DBusSession *dbus_session_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
DBusSession *dbus_session_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void dbus_session_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
DBusSession *dbus_session_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
DBusSession *dbus_session_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define DBUS_TYPE_SESSION_SKELETON (dbus_session_skeleton_get_type ())
#define DBUS_SESSION_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_SESSION_SKELETON, DBusSessionSkeleton))
#define DBUS_SESSION_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), DBUS_TYPE_SESSION_SKELETON, DBusSessionSkeletonClass))
#define DBUS_SESSION_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), DBUS_TYPE_SESSION_SKELETON, DBusSessionSkeletonClass))
#define DBUS_IS_SESSION_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_SESSION_SKELETON))
#define DBUS_IS_SESSION_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), DBUS_TYPE_SESSION_SKELETON))

typedef struct _DBusSessionSkeleton DBusSessionSkeleton;
typedef struct _DBusSessionSkeletonClass DBusSessionSkeletonClass;
typedef struct _DBusSessionSkeletonPrivate DBusSessionSkeletonPrivate;

struct _DBusSessionSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  DBusSessionSkeletonPrivate *priv;
};

struct _DBusSessionSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType dbus_session_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DBusSessionSkeleton, g_object_unref)
#endif

DBusSession *dbus_session_skeleton_new (void);


/* ------------------------------------------------------------------------ */
/* Declarations for org.sessiond.session1.Backlight */

#define DBUS_TYPE_BACKLIGHT (dbus_backlight_get_type ())
#define DBUS_BACKLIGHT(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_BACKLIGHT, DBusBacklight))
#define DBUS_IS_BACKLIGHT(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_BACKLIGHT))
#define DBUS_BACKLIGHT_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), DBUS_TYPE_BACKLIGHT, DBusBacklightIface))

struct _DBusBacklight;
typedef struct _DBusBacklight DBusBacklight;
typedef struct _DBusBacklightIface DBusBacklightIface;

struct _DBusBacklightIface
{
  GTypeInterface parent_iface;


  gboolean (*handle_inc_brightness) (
    DBusBacklight *object,
    GDBusMethodInvocation *invocation,
    gint arg_value);

  gboolean (*handle_set_brightness) (
    DBusBacklight *object,
    GDBusMethodInvocation *invocation,
    guint arg_brightness);

  guint  (*get_brightness) (DBusBacklight *object);

  const gchar * (*get_dev_path) (DBusBacklight *object);

  guint  (*get_max_brightness) (DBusBacklight *object);

  const gchar * (*get_name) (DBusBacklight *object);

  gboolean  (*get_online) (DBusBacklight *object);

  const gchar * (*get_subsystem) (DBusBacklight *object);

  const gchar * (*get_sys_path) (DBusBacklight *object);

};

GType dbus_backlight_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *dbus_backlight_interface_info (void);
guint dbus_backlight_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void dbus_backlight_complete_set_brightness (
    DBusBacklight *object,
    GDBusMethodInvocation *invocation);

void dbus_backlight_complete_inc_brightness (
    DBusBacklight *object,
    GDBusMethodInvocation *invocation,
    guint brightness);



/* D-Bus method calls: */
void dbus_backlight_call_set_brightness (
    DBusBacklight *proxy,
    guint arg_brightness,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_backlight_call_set_brightness_finish (
    DBusBacklight *proxy,
    GAsyncResult *res,
    GError **error);

gboolean dbus_backlight_call_set_brightness_sync (
    DBusBacklight *proxy,
    guint arg_brightness,
    GCancellable *cancellable,
    GError **error);

void dbus_backlight_call_inc_brightness (
    DBusBacklight *proxy,
    gint arg_value,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_backlight_call_inc_brightness_finish (
    DBusBacklight *proxy,
    guint *out_brightness,
    GAsyncResult *res,
    GError **error);

gboolean dbus_backlight_call_inc_brightness_sync (
    DBusBacklight *proxy,
    gint arg_value,
    guint *out_brightness,
    GCancellable *cancellable,
    GError **error);



/* D-Bus property accessors: */
gboolean dbus_backlight_get_online (DBusBacklight *object);
void dbus_backlight_set_online (DBusBacklight *object, gboolean value);

const gchar *dbus_backlight_get_name (DBusBacklight *object);
gchar *dbus_backlight_dup_name (DBusBacklight *object);
void dbus_backlight_set_name (DBusBacklight *object, const gchar *value);

const gchar *dbus_backlight_get_subsystem (DBusBacklight *object);
gchar *dbus_backlight_dup_subsystem (DBusBacklight *object);
void dbus_backlight_set_subsystem (DBusBacklight *object, const gchar *value);

const gchar *dbus_backlight_get_sys_path (DBusBacklight *object);
gchar *dbus_backlight_dup_sys_path (DBusBacklight *object);
void dbus_backlight_set_sys_path (DBusBacklight *object, const gchar *value);

const gchar *dbus_backlight_get_dev_path (DBusBacklight *object);
gchar *dbus_backlight_dup_dev_path (DBusBacklight *object);
void dbus_backlight_set_dev_path (DBusBacklight *object, const gchar *value);

guint dbus_backlight_get_max_brightness (DBusBacklight *object);
void dbus_backlight_set_max_brightness (DBusBacklight *object, guint value);

guint dbus_backlight_get_brightness (DBusBacklight *object);
void dbus_backlight_set_brightness (DBusBacklight *object, guint value);


/* ---- */

#define DBUS_TYPE_BACKLIGHT_PROXY (dbus_backlight_proxy_get_type ())
#define DBUS_BACKLIGHT_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_BACKLIGHT_PROXY, DBusBacklightProxy))
#define DBUS_BACKLIGHT_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), DBUS_TYPE_BACKLIGHT_PROXY, DBusBacklightProxyClass))
#define DBUS_BACKLIGHT_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), DBUS_TYPE_BACKLIGHT_PROXY, DBusBacklightProxyClass))
#define DBUS_IS_BACKLIGHT_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_BACKLIGHT_PROXY))
#define DBUS_IS_BACKLIGHT_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), DBUS_TYPE_BACKLIGHT_PROXY))

typedef struct _DBusBacklightProxy DBusBacklightProxy;
typedef struct _DBusBacklightProxyClass DBusBacklightProxyClass;
typedef struct _DBusBacklightProxyPrivate DBusBacklightProxyPrivate;

struct _DBusBacklightProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  DBusBacklightProxyPrivate *priv;
};

struct _DBusBacklightProxyClass
{
  GDBusProxyClass parent_class;
};

GType dbus_backlight_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DBusBacklightProxy, g_object_unref)
#endif

void dbus_backlight_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
DBusBacklight *dbus_backlight_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
DBusBacklight *dbus_backlight_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void dbus_backlight_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
DBusBacklight *dbus_backlight_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
DBusBacklight *dbus_backlight_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define DBUS_TYPE_BACKLIGHT_SKELETON (dbus_backlight_skeleton_get_type ())
#define DBUS_BACKLIGHT_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_BACKLIGHT_SKELETON, DBusBacklightSkeleton))
#define DBUS_BACKLIGHT_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), DBUS_TYPE_BACKLIGHT_SKELETON, DBusBacklightSkeletonClass))
#define DBUS_BACKLIGHT_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), DBUS_TYPE_BACKLIGHT_SKELETON, DBusBacklightSkeletonClass))
#define DBUS_IS_BACKLIGHT_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_BACKLIGHT_SKELETON))
#define DBUS_IS_BACKLIGHT_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), DBUS_TYPE_BACKLIGHT_SKELETON))

typedef struct _DBusBacklightSkeleton DBusBacklightSkeleton;
typedef struct _DBusBacklightSkeletonClass DBusBacklightSkeletonClass;
typedef struct _DBusBacklightSkeletonPrivate DBusBacklightSkeletonPrivate;

struct _DBusBacklightSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  DBusBacklightSkeletonPrivate *priv;
};

struct _DBusBacklightSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType dbus_backlight_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DBusBacklightSkeleton, g_object_unref)
#endif

DBusBacklight *dbus_backlight_skeleton_new (void);


/* ------------------------------------------------------------------------ */
/* Declarations for org.sessiond.session1.AudioSink */

#define DBUS_TYPE_AUDIO_SINK (dbus_audio_sink_get_type ())
#define DBUS_AUDIO_SINK(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_AUDIO_SINK, DBusAudioSink))
#define DBUS_IS_AUDIO_SINK(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_AUDIO_SINK))
#define DBUS_AUDIO_SINK_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), DBUS_TYPE_AUDIO_SINK, DBusAudioSinkIface))

struct _DBusAudioSink;
typedef struct _DBusAudioSink DBusAudioSink;
typedef struct _DBusAudioSinkIface DBusAudioSinkIface;

struct _DBusAudioSinkIface
{
  GTypeInterface parent_iface;



  gboolean (*handle_inc_volume) (
    DBusAudioSink *object,
    GDBusMethodInvocation *invocation,
    gdouble arg_value);

  gboolean (*handle_set_mute) (
    DBusAudioSink *object,
    GDBusMethodInvocation *invocation,
    gboolean arg_mute);

  gboolean (*handle_set_volume) (
    DBusAudioSink *object,
    GDBusMethodInvocation *invocation,
    gdouble arg_volume);

  gboolean (*handle_toggle_mute) (
    DBusAudioSink *object,
    GDBusMethodInvocation *invocation);

  guint  (*get_id) (DBusAudioSink *object);

  gboolean  (*get_mute) (DBusAudioSink *object);

  const gchar * (*get_name) (DBusAudioSink *object);

  gdouble  (*get_volume) (DBusAudioSink *object);

  void (*change_mute) (
    DBusAudioSink *object,
    gboolean arg_mute);

  void (*change_volume) (
    DBusAudioSink *object,
    gdouble arg_volume);

};

GType dbus_audio_sink_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *dbus_audio_sink_interface_info (void);
guint dbus_audio_sink_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void dbus_audio_sink_complete_set_volume (
    DBusAudioSink *object,
    GDBusMethodInvocation *invocation);

void dbus_audio_sink_complete_inc_volume (
    DBusAudioSink *object,
    GDBusMethodInvocation *invocation,
    gdouble volume);

void dbus_audio_sink_complete_set_mute (
    DBusAudioSink *object,
    GDBusMethodInvocation *invocation);

void dbus_audio_sink_complete_toggle_mute (
    DBusAudioSink *object,
    GDBusMethodInvocation *invocation,
    gboolean mute);



/* D-Bus signal emissions functions: */
void dbus_audio_sink_emit_change_mute (
    DBusAudioSink *object,
    gboolean arg_mute);

void dbus_audio_sink_emit_change_volume (
    DBusAudioSink *object,
    gdouble arg_volume);



/* D-Bus method calls: */
void dbus_audio_sink_call_set_volume (
    DBusAudioSink *proxy,
    gdouble arg_volume,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_audio_sink_call_set_volume_finish (
    DBusAudioSink *proxy,
    GAsyncResult *res,
    GError **error);

gboolean dbus_audio_sink_call_set_volume_sync (
    DBusAudioSink *proxy,
    gdouble arg_volume,
    GCancellable *cancellable,
    GError **error);

void dbus_audio_sink_call_inc_volume (
    DBusAudioSink *proxy,
    gdouble arg_value,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_audio_sink_call_inc_volume_finish (
    DBusAudioSink *proxy,
    gdouble *out_volume,
    GAsyncResult *res,
    GError **error);

gboolean dbus_audio_sink_call_inc_volume_sync (
    DBusAudioSink *proxy,
    gdouble arg_value,
    gdouble *out_volume,
    GCancellable *cancellable,
    GError **error);

void dbus_audio_sink_call_set_mute (
    DBusAudioSink *proxy,
    gboolean arg_mute,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_audio_sink_call_set_mute_finish (
    DBusAudioSink *proxy,
    GAsyncResult *res,
    GError **error);

gboolean dbus_audio_sink_call_set_mute_sync (
    DBusAudioSink *proxy,
    gboolean arg_mute,
    GCancellable *cancellable,
    GError **error);

void dbus_audio_sink_call_toggle_mute (
    DBusAudioSink *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_audio_sink_call_toggle_mute_finish (
    DBusAudioSink *proxy,
    gboolean *out_mute,
    GAsyncResult *res,
    GError **error);

gboolean dbus_audio_sink_call_toggle_mute_sync (
    DBusAudioSink *proxy,
    gboolean *out_mute,
    GCancellable *cancellable,
    GError **error);



/* D-Bus property accessors: */
guint dbus_audio_sink_get_id (DBusAudioSink *object);
void dbus_audio_sink_set_id (DBusAudioSink *object, guint value);

const gchar *dbus_audio_sink_get_name (DBusAudioSink *object);
gchar *dbus_audio_sink_dup_name (DBusAudioSink *object);
void dbus_audio_sink_set_name (DBusAudioSink *object, const gchar *value);

gboolean dbus_audio_sink_get_mute (DBusAudioSink *object);
void dbus_audio_sink_set_mute (DBusAudioSink *object, gboolean value);

gdouble dbus_audio_sink_get_volume (DBusAudioSink *object);
void dbus_audio_sink_set_volume (DBusAudioSink *object, gdouble value);


/* ---- */

#define DBUS_TYPE_AUDIO_SINK_PROXY (dbus_audio_sink_proxy_get_type ())
#define DBUS_AUDIO_SINK_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_AUDIO_SINK_PROXY, DBusAudioSinkProxy))
#define DBUS_AUDIO_SINK_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), DBUS_TYPE_AUDIO_SINK_PROXY, DBusAudioSinkProxyClass))
#define DBUS_AUDIO_SINK_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), DBUS_TYPE_AUDIO_SINK_PROXY, DBusAudioSinkProxyClass))
#define DBUS_IS_AUDIO_SINK_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_AUDIO_SINK_PROXY))
#define DBUS_IS_AUDIO_SINK_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), DBUS_TYPE_AUDIO_SINK_PROXY))

typedef struct _DBusAudioSinkProxy DBusAudioSinkProxy;
typedef struct _DBusAudioSinkProxyClass DBusAudioSinkProxyClass;
typedef struct _DBusAudioSinkProxyPrivate DBusAudioSinkProxyPrivate;

struct _DBusAudioSinkProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  DBusAudioSinkProxyPrivate *priv;
};

struct _DBusAudioSinkProxyClass
{
  GDBusProxyClass parent_class;
};

GType dbus_audio_sink_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DBusAudioSinkProxy, g_object_unref)
#endif

void dbus_audio_sink_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
DBusAudioSink *dbus_audio_sink_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
DBusAudioSink *dbus_audio_sink_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void dbus_audio_sink_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
DBusAudioSink *dbus_audio_sink_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
DBusAudioSink *dbus_audio_sink_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define DBUS_TYPE_AUDIO_SINK_SKELETON (dbus_audio_sink_skeleton_get_type ())
#define DBUS_AUDIO_SINK_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_AUDIO_SINK_SKELETON, DBusAudioSinkSkeleton))
#define DBUS_AUDIO_SINK_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), DBUS_TYPE_AUDIO_SINK_SKELETON, DBusAudioSinkSkeletonClass))
#define DBUS_AUDIO_SINK_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), DBUS_TYPE_AUDIO_SINK_SKELETON, DBusAudioSinkSkeletonClass))
#define DBUS_IS_AUDIO_SINK_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_AUDIO_SINK_SKELETON))
#define DBUS_IS_AUDIO_SINK_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), DBUS_TYPE_AUDIO_SINK_SKELETON))

typedef struct _DBusAudioSinkSkeleton DBusAudioSinkSkeleton;
typedef struct _DBusAudioSinkSkeletonClass DBusAudioSinkSkeletonClass;
typedef struct _DBusAudioSinkSkeletonPrivate DBusAudioSinkSkeletonPrivate;

struct _DBusAudioSinkSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  DBusAudioSinkSkeletonPrivate *priv;
};

struct _DBusAudioSinkSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType dbus_audio_sink_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DBusAudioSinkSkeleton, g_object_unref)
#endif

DBusAudioSink *dbus_audio_sink_skeleton_new (void);


G_END_DECLS

#endif /* __DBUS_GEN_H__ */
