/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include "dbus-gen.h"

#include <string.h>
#ifdef G_OS_UNIX
#  include <gio/gunixfdlist.h>
#endif

typedef struct
{
  GDBusArgInfo parent_struct;
  gboolean use_gvariant;
} _ExtendedGDBusArgInfo;

typedef struct
{
  GDBusMethodInfo parent_struct;
  const gchar *signal_name;
  gboolean pass_fdlist;
} _ExtendedGDBusMethodInfo;

typedef struct
{
  GDBusSignalInfo parent_struct;
  const gchar *signal_name;
} _ExtendedGDBusSignalInfo;

typedef struct
{
  GDBusPropertyInfo parent_struct;
  const gchar *hyphen_name;
  guint use_gvariant : 1;
  guint emits_changed_signal : 1;
} _ExtendedGDBusPropertyInfo;

typedef struct
{
  GDBusInterfaceInfo parent_struct;
  const gchar *hyphen_name;
} _ExtendedGDBusInterfaceInfo;

typedef struct
{
  const _ExtendedGDBusPropertyInfo *info;
  guint prop_id;
  GValue orig_value; /* the value before the change */
} ChangedProperty;

static void
_changed_property_free (ChangedProperty *data)
{
  g_value_unset (&data->orig_value);
  g_free (data);
}

static gboolean
_g_strv_equal0 (gchar **a, gchar **b)
{
  gboolean ret = FALSE;
  guint n;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  if (g_strv_length (a) != g_strv_length (b))
    goto out;
  for (n = 0; a[n] != NULL; n++)
    if (g_strcmp0 (a[n], b[n]) != 0)
      goto out;
  ret = TRUE;
out:
  return ret;
}

static gboolean
_g_variant_equal0 (GVariant *a, GVariant *b)
{
  gboolean ret = FALSE;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  ret = g_variant_equal (a, b);
out:
  return ret;
}

G_GNUC_UNUSED static gboolean
_g_value_equal (const GValue *a, const GValue *b)
{
  gboolean ret = FALSE;
  g_assert (G_VALUE_TYPE (a) == G_VALUE_TYPE (b));
  switch (G_VALUE_TYPE (a))
    {
      case G_TYPE_BOOLEAN:
        ret = (g_value_get_boolean (a) == g_value_get_boolean (b));
        break;
      case G_TYPE_UCHAR:
        ret = (g_value_get_uchar (a) == g_value_get_uchar (b));
        break;
      case G_TYPE_INT:
        ret = (g_value_get_int (a) == g_value_get_int (b));
        break;
      case G_TYPE_UINT:
        ret = (g_value_get_uint (a) == g_value_get_uint (b));
        break;
      case G_TYPE_INT64:
        ret = (g_value_get_int64 (a) == g_value_get_int64 (b));
        break;
      case G_TYPE_UINT64:
        ret = (g_value_get_uint64 (a) == g_value_get_uint64 (b));
        break;
      case G_TYPE_DOUBLE:
        {
          /* Avoid -Wfloat-equal warnings by doing a direct bit compare */
          gdouble da = g_value_get_double (a);
          gdouble db = g_value_get_double (b);
          ret = memcmp (&da, &db, sizeof (gdouble)) == 0;
        }
        break;
      case G_TYPE_STRING:
        ret = (g_strcmp0 (g_value_get_string (a), g_value_get_string (b)) == 0);
        break;
      case G_TYPE_VARIANT:
        ret = _g_variant_equal0 (g_value_get_variant (a), g_value_get_variant (b));
        break;
      default:
        if (G_VALUE_TYPE (a) == G_TYPE_STRV)
          ret = _g_strv_equal0 (g_value_get_boxed (a), g_value_get_boxed (b));
        else
          g_critical ("_g_value_equal() does not handle type %s", g_type_name (G_VALUE_TYPE (a)));
        break;
    }
  return ret;
}

/* ------------------------------------------------------------------------
 * Code for interface org.sessiond.session1.Session
 * ------------------------------------------------------------------------
 */

/**
 * SECTION:DBusSession
 * @title: DBusSession
 * @short_description: Generated C code for the org.sessiond.session1.Session D-Bus interface
 *
 * This section contains code for working with the <link linkend="gdbus-interface-org-sessiond-session1-Session.top_of_page">org.sessiond.session1.Session</link> D-Bus interface in C.
 */

/* ---- Introspection data for org.sessiond.session1.Session ---- */

static const _ExtendedGDBusMethodInfo _dbus_session_method_info_lock =
{
  {
    -1,
    (gchar *) "Lock",
    NULL,
    NULL,
    NULL
  },
  "handle-lock",
  FALSE
};

static const _ExtendedGDBusMethodInfo _dbus_session_method_info_unlock =
{
  {
    -1,
    (gchar *) "Unlock",
    NULL,
    NULL,
    NULL
  },
  "handle-unlock",
  FALSE
};

static const _ExtendedGDBusArgInfo _dbus_session_method_info_inhibit_IN_ARG_who =
{
  {
    -1,
    (gchar *) "who",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _dbus_session_method_info_inhibit_IN_ARG_why =
{
  {
    -1,
    (gchar *) "why",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_method_info_inhibit_IN_ARG_pointers[] =
{
  &_dbus_session_method_info_inhibit_IN_ARG_who.parent_struct,
  &_dbus_session_method_info_inhibit_IN_ARG_why.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _dbus_session_method_info_inhibit_OUT_ARG_id =
{
  {
    -1,
    (gchar *) "id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_method_info_inhibit_OUT_ARG_pointers[] =
{
  &_dbus_session_method_info_inhibit_OUT_ARG_id.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_session_method_info_inhibit =
{
  {
    -1,
    (gchar *) "Inhibit",
    (GDBusArgInfo **) &_dbus_session_method_info_inhibit_IN_ARG_pointers,
    (GDBusArgInfo **) &_dbus_session_method_info_inhibit_OUT_ARG_pointers,
    NULL
  },
  "handle-inhibit",
  FALSE
};

static const _ExtendedGDBusArgInfo _dbus_session_method_info_uninhibit_IN_ARG_id =
{
  {
    -1,
    (gchar *) "id",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_method_info_uninhibit_IN_ARG_pointers[] =
{
  &_dbus_session_method_info_uninhibit_IN_ARG_id.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_session_method_info_uninhibit =
{
  {
    -1,
    (gchar *) "Uninhibit",
    (GDBusArgInfo **) &_dbus_session_method_info_uninhibit_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-uninhibit",
  FALSE
};

static const _ExtendedGDBusArgInfo _dbus_session_method_info_stop_inhibitors_OUT_ARG_count =
{
  {
    -1,
    (gchar *) "count",
    (gchar *) "u",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_method_info_stop_inhibitors_OUT_ARG_pointers[] =
{
  &_dbus_session_method_info_stop_inhibitors_OUT_ARG_count.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_session_method_info_stop_inhibitors =
{
  {
    -1,
    (gchar *) "StopInhibitors",
    NULL,
    (GDBusArgInfo **) &_dbus_session_method_info_stop_inhibitors_OUT_ARG_pointers,
    NULL
  },
  "handle-stop-inhibitors",
  FALSE
};

static const _ExtendedGDBusArgInfo _dbus_session_method_info_list_inhibitors_OUT_ARG_inhibitors =
{
  {
    -1,
    (gchar *) "inhibitors",
    (gchar *) "a{s(tss)}",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_method_info_list_inhibitors_OUT_ARG_pointers[] =
{
  &_dbus_session_method_info_list_inhibitors_OUT_ARG_inhibitors.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_session_method_info_list_inhibitors =
{
  {
    -1,
    (gchar *) "ListInhibitors",
    NULL,
    (GDBusArgInfo **) &_dbus_session_method_info_list_inhibitors_OUT_ARG_pointers,
    NULL
  },
  "handle-list-inhibitors",
  FALSE
};

static const GDBusMethodInfo * const _dbus_session_method_info_pointers[] =
{
  &_dbus_session_method_info_lock.parent_struct,
  &_dbus_session_method_info_unlock.parent_struct,
  &_dbus_session_method_info_inhibit.parent_struct,
  &_dbus_session_method_info_uninhibit.parent_struct,
  &_dbus_session_method_info_stop_inhibitors.parent_struct,
  &_dbus_session_method_info_list_inhibitors.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_lock =
{
  {
    -1,
    (gchar *) "Lock",
    NULL,
    NULL
  },
  "lock"
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_unlock =
{
  {
    -1,
    (gchar *) "Unlock",
    NULL,
    NULL
  },
  "unlock"
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_idle =
{
  {
    -1,
    (gchar *) "Idle",
    NULL,
    NULL
  },
  "idle"
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_active =
{
  {
    -1,
    (gchar *) "Active",
    NULL,
    NULL
  },
  "active"
};

static const _ExtendedGDBusArgInfo _dbus_session_signal_info_inactive_ARG_seconds =
{
  {
    -1,
    (gchar *) "seconds",
    (gchar *) "u",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_signal_info_inactive_ARG_pointers[] =
{
  &_dbus_session_signal_info_inactive_ARG_seconds.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_inactive =
{
  {
    -1,
    (gchar *) "Inactive",
    (GDBusArgInfo **) &_dbus_session_signal_info_inactive_ARG_pointers,
    NULL
  },
  "inactive"
};

static const _ExtendedGDBusArgInfo _dbus_session_signal_info_prepare_for_sleep_ARG_state =
{
  {
    -1,
    (gchar *) "state",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_signal_info_prepare_for_sleep_ARG_pointers[] =
{
  &_dbus_session_signal_info_prepare_for_sleep_ARG_state.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_prepare_for_sleep =
{
  {
    -1,
    (gchar *) "PrepareForSleep",
    (GDBusArgInfo **) &_dbus_session_signal_info_prepare_for_sleep_ARG_pointers,
    NULL
  },
  "prepare-for-sleep"
};

static const _ExtendedGDBusArgInfo _dbus_session_signal_info_prepare_for_shutdown_ARG_state =
{
  {
    -1,
    (gchar *) "state",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_signal_info_prepare_for_shutdown_ARG_pointers[] =
{
  &_dbus_session_signal_info_prepare_for_shutdown_ARG_state.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_prepare_for_shutdown =
{
  {
    -1,
    (gchar *) "PrepareForShutdown",
    (GDBusArgInfo **) &_dbus_session_signal_info_prepare_for_shutdown_ARG_pointers,
    NULL
  },
  "prepare-for-shutdown"
};

static const _ExtendedGDBusArgInfo _dbus_session_signal_info_add_backlight_ARG_path =
{
  {
    -1,
    (gchar *) "path",
    (gchar *) "o",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_signal_info_add_backlight_ARG_pointers[] =
{
  &_dbus_session_signal_info_add_backlight_ARG_path.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_add_backlight =
{
  {
    -1,
    (gchar *) "AddBacklight",
    (GDBusArgInfo **) &_dbus_session_signal_info_add_backlight_ARG_pointers,
    NULL
  },
  "add-backlight"
};

static const _ExtendedGDBusArgInfo _dbus_session_signal_info_remove_backlight_ARG_path =
{
  {
    -1,
    (gchar *) "path",
    (gchar *) "o",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_signal_info_remove_backlight_ARG_pointers[] =
{
  &_dbus_session_signal_info_remove_backlight_ARG_path.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_remove_backlight =
{
  {
    -1,
    (gchar *) "RemoveBacklight",
    (GDBusArgInfo **) &_dbus_session_signal_info_remove_backlight_ARG_pointers,
    NULL
  },
  "remove-backlight"
};

static const _ExtendedGDBusArgInfo _dbus_session_signal_info_add_audio_sink_ARG_path =
{
  {
    -1,
    (gchar *) "path",
    (gchar *) "o",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_signal_info_add_audio_sink_ARG_pointers[] =
{
  &_dbus_session_signal_info_add_audio_sink_ARG_path.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_add_audio_sink =
{
  {
    -1,
    (gchar *) "AddAudioSink",
    (GDBusArgInfo **) &_dbus_session_signal_info_add_audio_sink_ARG_pointers,
    NULL
  },
  "add-audio-sink"
};

static const _ExtendedGDBusArgInfo _dbus_session_signal_info_remove_audio_sink_ARG_path =
{
  {
    -1,
    (gchar *) "path",
    (gchar *) "o",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_signal_info_remove_audio_sink_ARG_pointers[] =
{
  &_dbus_session_signal_info_remove_audio_sink_ARG_path.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_remove_audio_sink =
{
  {
    -1,
    (gchar *) "RemoveAudioSink",
    (GDBusArgInfo **) &_dbus_session_signal_info_remove_audio_sink_ARG_pointers,
    NULL
  },
  "remove-audio-sink"
};

static const _ExtendedGDBusArgInfo _dbus_session_signal_info_change_default_audio_sink_ARG_path =
{
  {
    -1,
    (gchar *) "path",
    (gchar *) "o",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_session_signal_info_change_default_audio_sink_ARG_pointers[] =
{
  &_dbus_session_signal_info_change_default_audio_sink_ARG_path.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_session_signal_info_change_default_audio_sink =
{
  {
    -1,
    (gchar *) "ChangeDefaultAudioSink",
    (GDBusArgInfo **) &_dbus_session_signal_info_change_default_audio_sink_ARG_pointers,
    NULL
  },
  "change-default-audio-sink"
};

static const GDBusSignalInfo * const _dbus_session_signal_info_pointers[] =
{
  &_dbus_session_signal_info_lock.parent_struct,
  &_dbus_session_signal_info_unlock.parent_struct,
  &_dbus_session_signal_info_idle.parent_struct,
  &_dbus_session_signal_info_active.parent_struct,
  &_dbus_session_signal_info_inactive.parent_struct,
  &_dbus_session_signal_info_prepare_for_sleep.parent_struct,
  &_dbus_session_signal_info_prepare_for_shutdown.parent_struct,
  &_dbus_session_signal_info_add_backlight.parent_struct,
  &_dbus_session_signal_info_remove_backlight.parent_struct,
  &_dbus_session_signal_info_add_audio_sink.parent_struct,
  &_dbus_session_signal_info_remove_audio_sink.parent_struct,
  &_dbus_session_signal_info_change_default_audio_sink.parent_struct,
  NULL
};

static const _ExtendedGDBusPropertyInfo _dbus_session_property_info_inhibited_hint =
{
  {
    -1,
    (gchar *) "InhibitedHint",
    (gchar *) "b",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "inhibited-hint",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_session_property_info_locked_hint =
{
  {
    -1,
    (gchar *) "LockedHint",
    (gchar *) "b",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "locked-hint",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_session_property_info_idle_hint =
{
  {
    -1,
    (gchar *) "IdleHint",
    (gchar *) "b",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "idle-hint",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_session_property_info_idle_since_hint =
{
  {
    -1,
    (gchar *) "IdleSinceHint",
    (gchar *) "t",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "idle-since-hint",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_session_property_info_idle_since_hint_monotonic =
{
  {
    -1,
    (gchar *) "IdleSinceHintMonotonic",
    (gchar *) "t",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "idle-since-hint-monotonic",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_session_property_info_backlights =
{
  {
    -1,
    (gchar *) "Backlights",
    (gchar *) "ao",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "backlights",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_session_property_info_audio_sinks =
{
  {
    -1,
    (gchar *) "AudioSinks",
    (gchar *) "ao",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "audio-sinks",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_session_property_info_default_audio_sink =
{
  {
    -1,
    (gchar *) "DefaultAudioSink",
    (gchar *) "o",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "default-audio-sink",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_session_property_info_version =
{
  {
    -1,
    (gchar *) "Version",
    (gchar *) "s",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "version",
  FALSE,
  TRUE
};

static const GDBusPropertyInfo * const _dbus_session_property_info_pointers[] =
{
  &_dbus_session_property_info_inhibited_hint.parent_struct,
  &_dbus_session_property_info_locked_hint.parent_struct,
  &_dbus_session_property_info_idle_hint.parent_struct,
  &_dbus_session_property_info_idle_since_hint.parent_struct,
  &_dbus_session_property_info_idle_since_hint_monotonic.parent_struct,
  &_dbus_session_property_info_backlights.parent_struct,
  &_dbus_session_property_info_audio_sinks.parent_struct,
  &_dbus_session_property_info_default_audio_sink.parent_struct,
  &_dbus_session_property_info_version.parent_struct,
  NULL
};

static const _ExtendedGDBusInterfaceInfo _dbus_session_interface_info =
{
  {
    -1,
    (gchar *) "org.sessiond.session1.Session",
    (GDBusMethodInfo **) &_dbus_session_method_info_pointers,
    (GDBusSignalInfo **) &_dbus_session_signal_info_pointers,
    (GDBusPropertyInfo **) &_dbus_session_property_info_pointers,
    NULL
  },
  "session",
};


/**
 * dbus_session_interface_info:
 *
 * Gets a machine-readable description of the <link linkend="gdbus-interface-org-sessiond-session1-Session.top_of_page">org.sessiond.session1.Session</link> D-Bus interface.
 *
 * Returns: (transfer none): A #GDBusInterfaceInfo. Do not free.
 */
GDBusInterfaceInfo *
dbus_session_interface_info (void)
{
  return (GDBusInterfaceInfo *) &_dbus_session_interface_info.parent_struct;
}

/**
 * dbus_session_override_properties:
 * @klass: The class structure for a #GObject derived class.
 * @property_id_begin: The property id to assign to the first overridden property.
 *
 * Overrides all #GObject properties in the #DBusSession interface for a concrete class.
 * The properties are overridden in the order they are defined.
 *
 * Returns: The last property id.
 */
guint
dbus_session_override_properties (GObjectClass *klass, guint property_id_begin)
{
  g_object_class_override_property (klass, property_id_begin++, "inhibited-hint");
  g_object_class_override_property (klass, property_id_begin++, "locked-hint");
  g_object_class_override_property (klass, property_id_begin++, "idle-hint");
  g_object_class_override_property (klass, property_id_begin++, "idle-since-hint");
  g_object_class_override_property (klass, property_id_begin++, "idle-since-hint-monotonic");
  g_object_class_override_property (klass, property_id_begin++, "backlights");
  g_object_class_override_property (klass, property_id_begin++, "audio-sinks");
  g_object_class_override_property (klass, property_id_begin++, "default-audio-sink");
  g_object_class_override_property (klass, property_id_begin++, "version");
  return property_id_begin - 1;
}



/**
 * DBusSession:
 *
 * Abstract interface type for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Session.top_of_page">org.sessiond.session1.Session</link>.
 */

/**
 * DBusSessionIface:
 * @parent_iface: The parent interface.
 * @handle_inhibit: Handler for the #DBusSession::handle-inhibit signal.
 * @handle_list_inhibitors: Handler for the #DBusSession::handle-list-inhibitors signal.
 * @handle_lock: Handler for the #DBusSession::handle-lock signal.
 * @handle_stop_inhibitors: Handler for the #DBusSession::handle-stop-inhibitors signal.
 * @handle_uninhibit: Handler for the #DBusSession::handle-uninhibit signal.
 * @handle_unlock: Handler for the #DBusSession::handle-unlock signal.
 * @get_audio_sinks: Getter for the #DBusSession:audio-sinks property.
 * @get_backlights: Getter for the #DBusSession:backlights property.
 * @get_default_audio_sink: Getter for the #DBusSession:default-audio-sink property.
 * @get_idle_hint: Getter for the #DBusSession:idle-hint property.
 * @get_idle_since_hint: Getter for the #DBusSession:idle-since-hint property.
 * @get_idle_since_hint_monotonic: Getter for the #DBusSession:idle-since-hint-monotonic property.
 * @get_inhibited_hint: Getter for the #DBusSession:inhibited-hint property.
 * @get_locked_hint: Getter for the #DBusSession:locked-hint property.
 * @get_version: Getter for the #DBusSession:version property.
 * @active: Handler for the #DBusSession::active signal.
 * @add_audio_sink: Handler for the #DBusSession::add-audio-sink signal.
 * @add_backlight: Handler for the #DBusSession::add-backlight signal.
 * @change_default_audio_sink: Handler for the #DBusSession::change-default-audio-sink signal.
 * @idle: Handler for the #DBusSession::idle signal.
 * @inactive: Handler for the #DBusSession::inactive signal.
 * @lock: Handler for the #DBusSession::lock signal.
 * @prepare_for_shutdown: Handler for the #DBusSession::prepare-for-shutdown signal.
 * @prepare_for_sleep: Handler for the #DBusSession::prepare-for-sleep signal.
 * @remove_audio_sink: Handler for the #DBusSession::remove-audio-sink signal.
 * @remove_backlight: Handler for the #DBusSession::remove-backlight signal.
 * @unlock: Handler for the #DBusSession::unlock signal.
 *
 * Virtual table for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Session.top_of_page">org.sessiond.session1.Session</link>.
 */

typedef DBusSessionIface DBusSessionInterface;
G_DEFINE_INTERFACE (DBusSession, dbus_session, G_TYPE_OBJECT)

static void
dbus_session_default_init (DBusSessionIface *iface)
{
  /* GObject signals for incoming D-Bus method calls: */
  /**
   * DBusSession::handle-lock:
   * @object: A #DBusSession.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-Session.Lock">Lock()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_session_complete_lock() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-lock",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, handle_lock),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /**
   * DBusSession::handle-unlock:
   * @object: A #DBusSession.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-Session.Unlock">Unlock()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_session_complete_unlock() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-unlock",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, handle_unlock),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /**
   * DBusSession::handle-inhibit:
   * @object: A #DBusSession.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_who: Argument passed by remote caller.
   * @arg_why: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-Session.Inhibit">Inhibit()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_session_complete_inhibit() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-inhibit",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, handle_inhibit),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    3,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING, G_TYPE_STRING);

  /**
   * DBusSession::handle-uninhibit:
   * @object: A #DBusSession.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_id: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-Session.Uninhibit">Uninhibit()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_session_complete_uninhibit() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-uninhibit",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, handle_uninhibit),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING);

  /**
   * DBusSession::handle-stop-inhibitors:
   * @object: A #DBusSession.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-Session.StopInhibitors">StopInhibitors()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_session_complete_stop_inhibitors() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-stop-inhibitors",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, handle_stop_inhibitors),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /**
   * DBusSession::handle-list-inhibitors:
   * @object: A #DBusSession.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-Session.ListInhibitors">ListInhibitors()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_session_complete_list_inhibitors() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-list-inhibitors",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, handle_list_inhibitors),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /* GObject signals for received D-Bus signals: */
  /**
   * DBusSession::lock:
   * @object: A #DBusSession.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.Lock">"Lock"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("lock",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, lock),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

  /**
   * DBusSession::unlock:
   * @object: A #DBusSession.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.Unlock">"Unlock"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("unlock",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, unlock),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

  /**
   * DBusSession::idle:
   * @object: A #DBusSession.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.Idle">"Idle"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("idle",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, idle),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

  /**
   * DBusSession::active:
   * @object: A #DBusSession.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.Active">"Active"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("active",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, active),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    0);

  /**
   * DBusSession::inactive:
   * @object: A #DBusSession.
   * @arg_seconds: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.Inactive">"Inactive"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("inactive",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, inactive),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_UINT);

  /**
   * DBusSession::prepare-for-sleep:
   * @object: A #DBusSession.
   * @arg_state: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.PrepareForSleep">"PrepareForSleep"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("prepare-for-sleep",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, prepare_for_sleep),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_BOOLEAN);

  /**
   * DBusSession::prepare-for-shutdown:
   * @object: A #DBusSession.
   * @arg_state: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.PrepareForShutdown">"PrepareForShutdown"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("prepare-for-shutdown",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, prepare_for_shutdown),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_BOOLEAN);

  /**
   * DBusSession::add-backlight:
   * @object: A #DBusSession.
   * @arg_path: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.AddBacklight">"AddBacklight"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("add-backlight",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, add_backlight),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_STRING);

  /**
   * DBusSession::remove-backlight:
   * @object: A #DBusSession.
   * @arg_path: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.RemoveBacklight">"RemoveBacklight"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("remove-backlight",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, remove_backlight),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_STRING);

  /**
   * DBusSession::add-audio-sink:
   * @object: A #DBusSession.
   * @arg_path: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.AddAudioSink">"AddAudioSink"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("add-audio-sink",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, add_audio_sink),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_STRING);

  /**
   * DBusSession::remove-audio-sink:
   * @object: A #DBusSession.
   * @arg_path: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.RemoveAudioSink">"RemoveAudioSink"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("remove-audio-sink",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, remove_audio_sink),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_STRING);

  /**
   * DBusSession::change-default-audio-sink:
   * @object: A #DBusSession.
   * @arg_path: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-Session.ChangeDefaultAudioSink">"ChangeDefaultAudioSink"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("change-default-audio-sink",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusSessionIface, change_default_audio_sink),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_STRING);

  /* GObject properties for D-Bus properties: */
  /**
   * DBusSession:inhibited-hint:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Session.InhibitedHint">"InhibitedHint"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_boolean ("inhibited-hint", "InhibitedHint", "InhibitedHint", FALSE, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusSession:locked-hint:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Session.LockedHint">"LockedHint"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_boolean ("locked-hint", "LockedHint", "LockedHint", FALSE, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusSession:idle-hint:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Session.IdleHint">"IdleHint"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_boolean ("idle-hint", "IdleHint", "IdleHint", FALSE, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusSession:idle-since-hint:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Session.IdleSinceHint">"IdleSinceHint"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_uint64 ("idle-since-hint", "IdleSinceHint", "IdleSinceHint", 0, G_MAXUINT64, 0, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusSession:idle-since-hint-monotonic:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Session.IdleSinceHintMonotonic">"IdleSinceHintMonotonic"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_uint64 ("idle-since-hint-monotonic", "IdleSinceHintMonotonic", "IdleSinceHintMonotonic", 0, G_MAXUINT64, 0, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusSession:backlights:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Session.Backlights">"Backlights"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_boxed ("backlights", "Backlights", "Backlights", G_TYPE_STRV, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusSession:audio-sinks:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Session.AudioSinks">"AudioSinks"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_boxed ("audio-sinks", "AudioSinks", "AudioSinks", G_TYPE_STRV, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusSession:default-audio-sink:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Session.DefaultAudioSink">"DefaultAudioSink"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_string ("default-audio-sink", "DefaultAudioSink", "DefaultAudioSink", NULL, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusSession:version:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Session.Version">"Version"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_string ("version", "Version", "Version", NULL, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
}

/**
 * dbus_session_get_inhibited_hint: (skip)
 * @object: A #DBusSession.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Session.InhibitedHint">"InhibitedHint"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
gboolean 
dbus_session_get_inhibited_hint (DBusSession *object)
{
  return DBUS_SESSION_GET_IFACE (object)->get_inhibited_hint (object);
}

/**
 * dbus_session_set_inhibited_hint: (skip)
 * @object: A #DBusSession.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Session.InhibitedHint">"InhibitedHint"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_session_set_inhibited_hint (DBusSession *object, gboolean value)
{
  g_object_set (G_OBJECT (object), "inhibited-hint", value, NULL);
}

/**
 * dbus_session_get_locked_hint: (skip)
 * @object: A #DBusSession.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Session.LockedHint">"LockedHint"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
gboolean 
dbus_session_get_locked_hint (DBusSession *object)
{
  return DBUS_SESSION_GET_IFACE (object)->get_locked_hint (object);
}

/**
 * dbus_session_set_locked_hint: (skip)
 * @object: A #DBusSession.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Session.LockedHint">"LockedHint"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_session_set_locked_hint (DBusSession *object, gboolean value)
{
  g_object_set (G_OBJECT (object), "locked-hint", value, NULL);
}

/**
 * dbus_session_get_idle_hint: (skip)
 * @object: A #DBusSession.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Session.IdleHint">"IdleHint"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
gboolean 
dbus_session_get_idle_hint (DBusSession *object)
{
  return DBUS_SESSION_GET_IFACE (object)->get_idle_hint (object);
}

/**
 * dbus_session_set_idle_hint: (skip)
 * @object: A #DBusSession.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Session.IdleHint">"IdleHint"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_session_set_idle_hint (DBusSession *object, gboolean value)
{
  g_object_set (G_OBJECT (object), "idle-hint", value, NULL);
}

/**
 * dbus_session_get_idle_since_hint: (skip)
 * @object: A #DBusSession.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Session.IdleSinceHint">"IdleSinceHint"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
guint64 
dbus_session_get_idle_since_hint (DBusSession *object)
{
  return DBUS_SESSION_GET_IFACE (object)->get_idle_since_hint (object);
}

/**
 * dbus_session_set_idle_since_hint: (skip)
 * @object: A #DBusSession.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Session.IdleSinceHint">"IdleSinceHint"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_session_set_idle_since_hint (DBusSession *object, guint64 value)
{
  g_object_set (G_OBJECT (object), "idle-since-hint", value, NULL);
}

/**
 * dbus_session_get_idle_since_hint_monotonic: (skip)
 * @object: A #DBusSession.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Session.IdleSinceHintMonotonic">"IdleSinceHintMonotonic"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
guint64 
dbus_session_get_idle_since_hint_monotonic (DBusSession *object)
{
  return DBUS_SESSION_GET_IFACE (object)->get_idle_since_hint_monotonic (object);
}

/**
 * dbus_session_set_idle_since_hint_monotonic: (skip)
 * @object: A #DBusSession.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Session.IdleSinceHintMonotonic">"IdleSinceHintMonotonic"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_session_set_idle_since_hint_monotonic (DBusSession *object, guint64 value)
{
  g_object_set (G_OBJECT (object), "idle-since-hint-monotonic", value, NULL);
}

/**
 * dbus_session_get_backlights: (skip)
 * @object: A #DBusSession.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Session.Backlights">"Backlights"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where @object was constructed. Use dbus_session_dup_backlights() if on another thread.
 *
 * Returns: (transfer none) (nullable): The property value or %NULL if the property is not set. Do not free the returned value, it belongs to @object.
 */
const gchar *const *
dbus_session_get_backlights (DBusSession *object)
{
  return DBUS_SESSION_GET_IFACE (object)->get_backlights (object);
}

/**
 * dbus_session_dup_backlights: (skip)
 * @object: A #DBusSession.
 *
 * Gets a copy of the <link linkend="gdbus-property-org-sessiond-session1-Session.Backlights">"Backlights"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: (transfer full) (nullable): The property value or %NULL if the property is not set. The returned value should be freed with g_strfreev().
 */
gchar **
dbus_session_dup_backlights (DBusSession *object)
{
  gchar **value;
  g_object_get (G_OBJECT (object), "backlights", &value, NULL);
  return value;
}

/**
 * dbus_session_set_backlights: (skip)
 * @object: A #DBusSession.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Session.Backlights">"Backlights"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_session_set_backlights (DBusSession *object, const gchar *const *value)
{
  g_object_set (G_OBJECT (object), "backlights", value, NULL);
}

/**
 * dbus_session_get_audio_sinks: (skip)
 * @object: A #DBusSession.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Session.AudioSinks">"AudioSinks"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where @object was constructed. Use dbus_session_dup_audio_sinks() if on another thread.
 *
 * Returns: (transfer none) (nullable): The property value or %NULL if the property is not set. Do not free the returned value, it belongs to @object.
 */
const gchar *const *
dbus_session_get_audio_sinks (DBusSession *object)
{
  return DBUS_SESSION_GET_IFACE (object)->get_audio_sinks (object);
}

/**
 * dbus_session_dup_audio_sinks: (skip)
 * @object: A #DBusSession.
 *
 * Gets a copy of the <link linkend="gdbus-property-org-sessiond-session1-Session.AudioSinks">"AudioSinks"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: (transfer full) (nullable): The property value or %NULL if the property is not set. The returned value should be freed with g_strfreev().
 */
gchar **
dbus_session_dup_audio_sinks (DBusSession *object)
{
  gchar **value;
  g_object_get (G_OBJECT (object), "audio-sinks", &value, NULL);
  return value;
}

/**
 * dbus_session_set_audio_sinks: (skip)
 * @object: A #DBusSession.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Session.AudioSinks">"AudioSinks"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_session_set_audio_sinks (DBusSession *object, const gchar *const *value)
{
  g_object_set (G_OBJECT (object), "audio-sinks", value, NULL);
}

/**
 * dbus_session_get_default_audio_sink: (skip)
 * @object: A #DBusSession.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Session.DefaultAudioSink">"DefaultAudioSink"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where @object was constructed. Use dbus_session_dup_default_audio_sink() if on another thread.
 *
 * Returns: (transfer none) (nullable): The property value or %NULL if the property is not set. Do not free the returned value, it belongs to @object.
 */
const gchar *
dbus_session_get_default_audio_sink (DBusSession *object)
{
  return DBUS_SESSION_GET_IFACE (object)->get_default_audio_sink (object);
}

/**
 * dbus_session_dup_default_audio_sink: (skip)
 * @object: A #DBusSession.
 *
 * Gets a copy of the <link linkend="gdbus-property-org-sessiond-session1-Session.DefaultAudioSink">"DefaultAudioSink"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: (transfer full) (nullable): The property value or %NULL if the property is not set. The returned value should be freed with g_free().
 */
gchar *
dbus_session_dup_default_audio_sink (DBusSession *object)
{
  gchar *value;
  g_object_get (G_OBJECT (object), "default-audio-sink", &value, NULL);
  return value;
}

/**
 * dbus_session_set_default_audio_sink: (skip)
 * @object: A #DBusSession.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Session.DefaultAudioSink">"DefaultAudioSink"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_session_set_default_audio_sink (DBusSession *object, const gchar *value)
{
  g_object_set (G_OBJECT (object), "default-audio-sink", value, NULL);
}

/**
 * dbus_session_get_version: (skip)
 * @object: A #DBusSession.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Session.Version">"Version"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where @object was constructed. Use dbus_session_dup_version() if on another thread.
 *
 * Returns: (transfer none) (nullable): The property value or %NULL if the property is not set. Do not free the returned value, it belongs to @object.
 */
const gchar *
dbus_session_get_version (DBusSession *object)
{
  return DBUS_SESSION_GET_IFACE (object)->get_version (object);
}

/**
 * dbus_session_dup_version: (skip)
 * @object: A #DBusSession.
 *
 * Gets a copy of the <link linkend="gdbus-property-org-sessiond-session1-Session.Version">"Version"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: (transfer full) (nullable): The property value or %NULL if the property is not set. The returned value should be freed with g_free().
 */
gchar *
dbus_session_dup_version (DBusSession *object)
{
  gchar *value;
  g_object_get (G_OBJECT (object), "version", &value, NULL);
  return value;
}

/**
 * dbus_session_set_version: (skip)
 * @object: A #DBusSession.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Session.Version">"Version"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_session_set_version (DBusSession *object, const gchar *value)
{
  g_object_set (G_OBJECT (object), "version", value, NULL);
}

/**
 * dbus_session_emit_lock:
 * @object: A #DBusSession.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.Lock">"Lock"</link> D-Bus signal.
 */
void
dbus_session_emit_lock (
    DBusSession *object)
{
  g_signal_emit_by_name (object, "lock");
}

/**
 * dbus_session_emit_unlock:
 * @object: A #DBusSession.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.Unlock">"Unlock"</link> D-Bus signal.
 */
void
dbus_session_emit_unlock (
    DBusSession *object)
{
  g_signal_emit_by_name (object, "unlock");
}

/**
 * dbus_session_emit_idle:
 * @object: A #DBusSession.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.Idle">"Idle"</link> D-Bus signal.
 */
void
dbus_session_emit_idle (
    DBusSession *object)
{
  g_signal_emit_by_name (object, "idle");
}

/**
 * dbus_session_emit_active:
 * @object: A #DBusSession.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.Active">"Active"</link> D-Bus signal.
 */
void
dbus_session_emit_active (
    DBusSession *object)
{
  g_signal_emit_by_name (object, "active");
}

/**
 * dbus_session_emit_inactive:
 * @object: A #DBusSession.
 * @arg_seconds: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.Inactive">"Inactive"</link> D-Bus signal.
 */
void
dbus_session_emit_inactive (
    DBusSession *object,
    guint arg_seconds)
{
  g_signal_emit_by_name (object, "inactive", arg_seconds);
}

/**
 * dbus_session_emit_prepare_for_sleep:
 * @object: A #DBusSession.
 * @arg_state: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.PrepareForSleep">"PrepareForSleep"</link> D-Bus signal.
 */
void
dbus_session_emit_prepare_for_sleep (
    DBusSession *object,
    gboolean arg_state)
{
  g_signal_emit_by_name (object, "prepare-for-sleep", arg_state);
}

/**
 * dbus_session_emit_prepare_for_shutdown:
 * @object: A #DBusSession.
 * @arg_state: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.PrepareForShutdown">"PrepareForShutdown"</link> D-Bus signal.
 */
void
dbus_session_emit_prepare_for_shutdown (
    DBusSession *object,
    gboolean arg_state)
{
  g_signal_emit_by_name (object, "prepare-for-shutdown", arg_state);
}

/**
 * dbus_session_emit_add_backlight:
 * @object: A #DBusSession.
 * @arg_path: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.AddBacklight">"AddBacklight"</link> D-Bus signal.
 */
void
dbus_session_emit_add_backlight (
    DBusSession *object,
    const gchar *arg_path)
{
  g_signal_emit_by_name (object, "add-backlight", arg_path);
}

/**
 * dbus_session_emit_remove_backlight:
 * @object: A #DBusSession.
 * @arg_path: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.RemoveBacklight">"RemoveBacklight"</link> D-Bus signal.
 */
void
dbus_session_emit_remove_backlight (
    DBusSession *object,
    const gchar *arg_path)
{
  g_signal_emit_by_name (object, "remove-backlight", arg_path);
}

/**
 * dbus_session_emit_add_audio_sink:
 * @object: A #DBusSession.
 * @arg_path: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.AddAudioSink">"AddAudioSink"</link> D-Bus signal.
 */
void
dbus_session_emit_add_audio_sink (
    DBusSession *object,
    const gchar *arg_path)
{
  g_signal_emit_by_name (object, "add-audio-sink", arg_path);
}

/**
 * dbus_session_emit_remove_audio_sink:
 * @object: A #DBusSession.
 * @arg_path: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.RemoveAudioSink">"RemoveAudioSink"</link> D-Bus signal.
 */
void
dbus_session_emit_remove_audio_sink (
    DBusSession *object,
    const gchar *arg_path)
{
  g_signal_emit_by_name (object, "remove-audio-sink", arg_path);
}

/**
 * dbus_session_emit_change_default_audio_sink:
 * @object: A #DBusSession.
 * @arg_path: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-Session.ChangeDefaultAudioSink">"ChangeDefaultAudioSink"</link> D-Bus signal.
 */
void
dbus_session_emit_change_default_audio_sink (
    DBusSession *object,
    const gchar *arg_path)
{
  g_signal_emit_by_name (object, "change-default-audio-sink", arg_path);
}

/**
 * dbus_session_call_lock:
 * @proxy: A #DBusSessionProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.Lock">Lock()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_session_call_lock_finish() to get the result of the operation.
 *
 * See dbus_session_call_lock_sync() for the synchronous, blocking version of this method.
 */
void
dbus_session_call_lock (
    DBusSession *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "Lock",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_session_call_lock_finish:
 * @proxy: A #DBusSessionProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_session_call_lock().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_session_call_lock().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_lock_finish (
    DBusSession *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_lock_sync:
 * @proxy: A #DBusSessionProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.Lock">Lock()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_session_call_lock() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_lock_sync (
    DBusSession *proxy,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "Lock",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_unlock:
 * @proxy: A #DBusSessionProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.Unlock">Unlock()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_session_call_unlock_finish() to get the result of the operation.
 *
 * See dbus_session_call_unlock_sync() for the synchronous, blocking version of this method.
 */
void
dbus_session_call_unlock (
    DBusSession *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "Unlock",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_session_call_unlock_finish:
 * @proxy: A #DBusSessionProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_session_call_unlock().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_session_call_unlock().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_unlock_finish (
    DBusSession *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_unlock_sync:
 * @proxy: A #DBusSessionProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.Unlock">Unlock()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_session_call_unlock() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_unlock_sync (
    DBusSession *proxy,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "Unlock",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_inhibit:
 * @proxy: A #DBusSessionProxy.
 * @arg_who: Argument to pass with the method invocation.
 * @arg_why: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.Inhibit">Inhibit()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_session_call_inhibit_finish() to get the result of the operation.
 *
 * See dbus_session_call_inhibit_sync() for the synchronous, blocking version of this method.
 */
void
dbus_session_call_inhibit (
    DBusSession *proxy,
    const gchar *arg_who,
    const gchar *arg_why,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "Inhibit",
    g_variant_new ("(ss)",
                   arg_who,
                   arg_why),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_session_call_inhibit_finish:
 * @proxy: A #DBusSessionProxy.
 * @out_id: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_session_call_inhibit().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_session_call_inhibit().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_inhibit_finish (
    DBusSession *proxy,
    gchar **out_id,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_id);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_inhibit_sync:
 * @proxy: A #DBusSessionProxy.
 * @arg_who: Argument to pass with the method invocation.
 * @arg_why: Argument to pass with the method invocation.
 * @out_id: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.Inhibit">Inhibit()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_session_call_inhibit() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_inhibit_sync (
    DBusSession *proxy,
    const gchar *arg_who,
    const gchar *arg_why,
    gchar **out_id,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "Inhibit",
    g_variant_new ("(ss)",
                   arg_who,
                   arg_why),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(s)",
                 out_id);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_uninhibit:
 * @proxy: A #DBusSessionProxy.
 * @arg_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.Uninhibit">Uninhibit()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_session_call_uninhibit_finish() to get the result of the operation.
 *
 * See dbus_session_call_uninhibit_sync() for the synchronous, blocking version of this method.
 */
void
dbus_session_call_uninhibit (
    DBusSession *proxy,
    const gchar *arg_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "Uninhibit",
    g_variant_new ("(s)",
                   arg_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_session_call_uninhibit_finish:
 * @proxy: A #DBusSessionProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_session_call_uninhibit().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_session_call_uninhibit().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_uninhibit_finish (
    DBusSession *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_uninhibit_sync:
 * @proxy: A #DBusSessionProxy.
 * @arg_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.Uninhibit">Uninhibit()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_session_call_uninhibit() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_uninhibit_sync (
    DBusSession *proxy,
    const gchar *arg_id,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "Uninhibit",
    g_variant_new ("(s)",
                   arg_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_stop_inhibitors:
 * @proxy: A #DBusSessionProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.StopInhibitors">StopInhibitors()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_session_call_stop_inhibitors_finish() to get the result of the operation.
 *
 * See dbus_session_call_stop_inhibitors_sync() for the synchronous, blocking version of this method.
 */
void
dbus_session_call_stop_inhibitors (
    DBusSession *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "StopInhibitors",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_session_call_stop_inhibitors_finish:
 * @proxy: A #DBusSessionProxy.
 * @out_count: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_session_call_stop_inhibitors().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_session_call_stop_inhibitors().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_stop_inhibitors_finish (
    DBusSession *proxy,
    guint *out_count,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(u)",
                 out_count);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_stop_inhibitors_sync:
 * @proxy: A #DBusSessionProxy.
 * @out_count: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.StopInhibitors">StopInhibitors()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_session_call_stop_inhibitors() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_stop_inhibitors_sync (
    DBusSession *proxy,
    guint *out_count,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "StopInhibitors",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(u)",
                 out_count);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_list_inhibitors:
 * @proxy: A #DBusSessionProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.ListInhibitors">ListInhibitors()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_session_call_list_inhibitors_finish() to get the result of the operation.
 *
 * See dbus_session_call_list_inhibitors_sync() for the synchronous, blocking version of this method.
 */
void
dbus_session_call_list_inhibitors (
    DBusSession *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "ListInhibitors",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_session_call_list_inhibitors_finish:
 * @proxy: A #DBusSessionProxy.
 * @out_inhibitors: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_session_call_list_inhibitors().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_session_call_list_inhibitors().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_list_inhibitors_finish (
    DBusSession *proxy,
    GVariant **out_inhibitors,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(@a{s(tss)})",
                 out_inhibitors);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_call_list_inhibitors_sync:
 * @proxy: A #DBusSessionProxy.
 * @out_inhibitors: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Session.ListInhibitors">ListInhibitors()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_session_call_list_inhibitors() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_session_call_list_inhibitors_sync (
    DBusSession *proxy,
    GVariant **out_inhibitors,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "ListInhibitors",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(@a{s(tss)})",
                 out_inhibitors);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_session_complete_lock:
 * @object: A #DBusSession.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-Session.Lock">Lock()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_session_complete_lock (
    DBusSession *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * dbus_session_complete_unlock:
 * @object: A #DBusSession.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-Session.Unlock">Unlock()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_session_complete_unlock (
    DBusSession *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * dbus_session_complete_inhibit:
 * @object: A #DBusSession.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @id: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-Session.Inhibit">Inhibit()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_session_complete_inhibit (
    DBusSession *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    const gchar *id)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(s)",
                   id));
}

/**
 * dbus_session_complete_uninhibit:
 * @object: A #DBusSession.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-Session.Uninhibit">Uninhibit()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_session_complete_uninhibit (
    DBusSession *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * dbus_session_complete_stop_inhibitors:
 * @object: A #DBusSession.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @count: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-Session.StopInhibitors">StopInhibitors()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_session_complete_stop_inhibitors (
    DBusSession *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    guint count)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(u)",
                   count));
}

/**
 * dbus_session_complete_list_inhibitors:
 * @object: A #DBusSession.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @inhibitors: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-Session.ListInhibitors">ListInhibitors()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_session_complete_list_inhibitors (
    DBusSession *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    GVariant *inhibitors)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(@a{s(tss)})",
                   inhibitors));
}

/* ------------------------------------------------------------------------ */

/**
 * DBusSessionProxy:
 *
 * The #DBusSessionProxy structure contains only private data and should only be accessed using the provided API.
 */

/**
 * DBusSessionProxyClass:
 * @parent_class: The parent class.
 *
 * Class structure for #DBusSessionProxy.
 */

struct _DBusSessionProxyPrivate
{
  GData *qdata;
};

static void dbus_session_proxy_iface_init (DBusSessionIface *iface);

#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (DBusSessionProxy, dbus_session_proxy, G_TYPE_DBUS_PROXY,
                         G_ADD_PRIVATE (DBusSessionProxy)
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_SESSION, dbus_session_proxy_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (DBusSessionProxy, dbus_session_proxy, G_TYPE_DBUS_PROXY,
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_SESSION, dbus_session_proxy_iface_init))

#endif
static void
dbus_session_proxy_finalize (GObject *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  g_datalist_clear (&proxy->priv->qdata);
  G_OBJECT_CLASS (dbus_session_proxy_parent_class)->finalize (object);
}

static void
dbus_session_proxy_get_property (GObject      *object,
  guint         prop_id,
  GValue       *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
  const _ExtendedGDBusPropertyInfo *info;
  GVariant *variant;
  g_assert (prop_id != 0 && prop_id - 1 < 9);
  info = (const _ExtendedGDBusPropertyInfo *) _dbus_session_property_info_pointers[prop_id - 1];
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (object), info->parent_struct.name);
  if (info->use_gvariant)
    {
      g_value_set_variant (value, variant);
    }
  else
    {
      if (variant != NULL)
        g_dbus_gvariant_to_gvalue (variant, value);
    }
  if (variant != NULL)
    g_variant_unref (variant);
}

static void
dbus_session_proxy_set_property_cb (GDBusProxy *proxy,
  GAsyncResult *res,
  gpointer      user_data)
{
  const _ExtendedGDBusPropertyInfo *info = user_data;
  GError *error;
  GVariant *_ret;
  error = NULL;
  _ret = g_dbus_proxy_call_finish (proxy, res, &error);
  if (!_ret)
    {
      g_warning ("Error setting property '%s' on interface org.sessiond.session1.Session: %s (%s, %d)",
                 info->parent_struct.name, 
                 error->message, g_quark_to_string (error->domain), error->code);
      g_error_free (error);
    }
  else
    {
      g_variant_unref (_ret);
    }
}

static void
dbus_session_proxy_set_property (GObject      *object,
  guint         prop_id,
  const GValue *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
  const _ExtendedGDBusPropertyInfo *info;
  GVariant *variant;
  g_assert (prop_id != 0 && prop_id - 1 < 9);
  info = (const _ExtendedGDBusPropertyInfo *) _dbus_session_property_info_pointers[prop_id - 1];
  variant = g_dbus_gvalue_to_gvariant (value, G_VARIANT_TYPE (info->parent_struct.signature));
  g_dbus_proxy_call (G_DBUS_PROXY (object),
    "org.freedesktop.DBus.Properties.Set",
    g_variant_new ("(ssv)", "org.sessiond.session1.Session", info->parent_struct.name, variant),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    NULL, (GAsyncReadyCallback) dbus_session_proxy_set_property_cb, (GDBusPropertyInfo *) &info->parent_struct);
  g_variant_unref (variant);
}

static void
dbus_session_proxy_g_signal (GDBusProxy *proxy,
  const gchar *sender_name G_GNUC_UNUSED,
  const gchar *signal_name,
  GVariant *parameters)
{
  _ExtendedGDBusSignalInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  gsize n;
  guint signal_id;
  info = (_ExtendedGDBusSignalInfo *) g_dbus_interface_info_lookup_signal ((GDBusInterfaceInfo *) &_dbus_session_interface_info.parent_struct, signal_name);
  if (info == NULL)
    return;
  num_params = g_variant_n_children (parameters);
  paramv = g_new0 (GValue, num_params + 1);
  g_value_init (&paramv[0], DBUS_TYPE_SESSION);
  g_value_set_object (&paramv[0], proxy);
  g_variant_iter_init (&iter, parameters);
  n = 1;
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.args[n - 1];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, DBUS_TYPE_SESSION);
  g_signal_emitv (paramv, signal_id, 0, NULL);
  for (n = 0; n < num_params + 1; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static void
dbus_session_proxy_g_properties_changed (GDBusProxy *_proxy,
  GVariant *changed_properties,
  const gchar *const *invalidated_properties)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (_proxy);
  guint n;
  const gchar *key;
  GVariantIter *iter;
  _ExtendedGDBusPropertyInfo *info;
  g_variant_get (changed_properties, "a{sv}", &iter);
  while (g_variant_iter_next (iter, "{&sv}", &key, NULL))
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_session_interface_info.parent_struct, key);
      g_datalist_remove_data (&proxy->priv->qdata, key);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
  g_variant_iter_free (iter);
  for (n = 0; invalidated_properties[n] != NULL; n++)
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_session_interface_info.parent_struct, invalidated_properties[n]);
      g_datalist_remove_data (&proxy->priv->qdata, invalidated_properties[n]);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
}

static gboolean 
dbus_session_proxy_get_inhibited_hint (DBusSession *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  GVariant *variant;
  gboolean value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "InhibitedHint");
  if (variant != NULL)
    {
      value = g_variant_get_boolean (variant);
      g_variant_unref (variant);
    }
  return value;
}

static gboolean 
dbus_session_proxy_get_locked_hint (DBusSession *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  GVariant *variant;
  gboolean value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "LockedHint");
  if (variant != NULL)
    {
      value = g_variant_get_boolean (variant);
      g_variant_unref (variant);
    }
  return value;
}

static gboolean 
dbus_session_proxy_get_idle_hint (DBusSession *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  GVariant *variant;
  gboolean value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "IdleHint");
  if (variant != NULL)
    {
      value = g_variant_get_boolean (variant);
      g_variant_unref (variant);
    }
  return value;
}

static guint64 
dbus_session_proxy_get_idle_since_hint (DBusSession *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  GVariant *variant;
  guint64 value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "IdleSinceHint");
  if (variant != NULL)
    {
      value = g_variant_get_uint64 (variant);
      g_variant_unref (variant);
    }
  return value;
}

static guint64 
dbus_session_proxy_get_idle_since_hint_monotonic (DBusSession *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  GVariant *variant;
  guint64 value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "IdleSinceHintMonotonic");
  if (variant != NULL)
    {
      value = g_variant_get_uint64 (variant);
      g_variant_unref (variant);
    }
  return value;
}

static const gchar *const *
dbus_session_proxy_get_backlights (DBusSession *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  GVariant *variant;
  const gchar *const *value = NULL;
  value = g_datalist_get_data (&proxy->priv->qdata, "Backlights");
  if (value != NULL)
    return value;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Backlights");
  if (variant != NULL)
    {
      value = g_variant_get_objv (variant, NULL);
      g_datalist_set_data_full (&proxy->priv->qdata, "Backlights", (gpointer) value, g_free);
      g_variant_unref (variant);
    }
  return value;
}

static const gchar *const *
dbus_session_proxy_get_audio_sinks (DBusSession *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  GVariant *variant;
  const gchar *const *value = NULL;
  value = g_datalist_get_data (&proxy->priv->qdata, "AudioSinks");
  if (value != NULL)
    return value;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "AudioSinks");
  if (variant != NULL)
    {
      value = g_variant_get_objv (variant, NULL);
      g_datalist_set_data_full (&proxy->priv->qdata, "AudioSinks", (gpointer) value, g_free);
      g_variant_unref (variant);
    }
  return value;
}

static const gchar *
dbus_session_proxy_get_default_audio_sink (DBusSession *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  GVariant *variant;
  const gchar *value = NULL;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "DefaultAudioSink");
  if (variant != NULL)
    {
      value = g_variant_get_string (variant, NULL);
      g_variant_unref (variant);
    }
  return value;
}

static const gchar *
dbus_session_proxy_get_version (DBusSession *object)
{
  DBusSessionProxy *proxy = DBUS_SESSION_PROXY (object);
  GVariant *variant;
  const gchar *value = NULL;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Version");
  if (variant != NULL)
    {
      value = g_variant_get_string (variant, NULL);
      g_variant_unref (variant);
    }
  return value;
}

static void
dbus_session_proxy_init (DBusSessionProxy *proxy)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  proxy->priv = dbus_session_proxy_get_instance_private (proxy);
#else
  proxy->priv = G_TYPE_INSTANCE_GET_PRIVATE (proxy, DBUS_TYPE_SESSION_PROXY, DBusSessionProxyPrivate);
#endif

  g_dbus_proxy_set_interface_info (G_DBUS_PROXY (proxy), dbus_session_interface_info ());
}

static void
dbus_session_proxy_class_init (DBusSessionProxyClass *klass)
{
  GObjectClass *gobject_class;
  GDBusProxyClass *proxy_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize     = dbus_session_proxy_finalize;
  gobject_class->get_property = dbus_session_proxy_get_property;
  gobject_class->set_property = dbus_session_proxy_set_property;

  proxy_class = G_DBUS_PROXY_CLASS (klass);
  proxy_class->g_signal = dbus_session_proxy_g_signal;
  proxy_class->g_properties_changed = dbus_session_proxy_g_properties_changed;

  dbus_session_override_properties (gobject_class, 1);

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (DBusSessionProxyPrivate));
#endif
}

static void
dbus_session_proxy_iface_init (DBusSessionIface *iface)
{
  iface->get_inhibited_hint = dbus_session_proxy_get_inhibited_hint;
  iface->get_locked_hint = dbus_session_proxy_get_locked_hint;
  iface->get_idle_hint = dbus_session_proxy_get_idle_hint;
  iface->get_idle_since_hint = dbus_session_proxy_get_idle_since_hint;
  iface->get_idle_since_hint_monotonic = dbus_session_proxy_get_idle_since_hint_monotonic;
  iface->get_backlights = dbus_session_proxy_get_backlights;
  iface->get_audio_sinks = dbus_session_proxy_get_audio_sinks;
  iface->get_default_audio_sink = dbus_session_proxy_get_default_audio_sink;
  iface->get_version = dbus_session_proxy_get_version;
}

/**
 * dbus_session_proxy_new:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Session.top_of_page">org.sessiond.session1.Session</link>. See g_dbus_proxy_new() for more details.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_session_proxy_new_finish() to get the result of the operation.
 *
 * See dbus_session_proxy_new_sync() for the synchronous, blocking version of this constructor.
 */
void
dbus_session_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (DBUS_TYPE_SESSION_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.Session", NULL);
}

/**
 * dbus_session_proxy_new_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_session_proxy_new().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with dbus_session_proxy_new().
 *
 * Returns: (transfer full) (type DBusSessionProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusSession *
dbus_session_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return DBUS_SESSION (ret);
  else
    return NULL;
}

/**
 * dbus_session_proxy_new_sync:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Synchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Session.top_of_page">org.sessiond.session1.Session</link>. See g_dbus_proxy_new_sync() for more details.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See dbus_session_proxy_new() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type DBusSessionProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusSession *
dbus_session_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (DBUS_TYPE_SESSION_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.Session", NULL);
  if (ret != NULL)
    return DBUS_SESSION (ret);
  else
    return NULL;
}


/**
 * dbus_session_proxy_new_for_bus:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Like dbus_session_proxy_new() but takes a #GBusType instead of a #GDBusConnection.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_session_proxy_new_for_bus_finish() to get the result of the operation.
 *
 * See dbus_session_proxy_new_for_bus_sync() for the synchronous, blocking version of this constructor.
 */
void
dbus_session_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (DBUS_TYPE_SESSION_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.Session", NULL);
}

/**
 * dbus_session_proxy_new_for_bus_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_session_proxy_new_for_bus().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with dbus_session_proxy_new_for_bus().
 *
 * Returns: (transfer full) (type DBusSessionProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusSession *
dbus_session_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return DBUS_SESSION (ret);
  else
    return NULL;
}

/**
 * dbus_session_proxy_new_for_bus_sync:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Like dbus_session_proxy_new_sync() but takes a #GBusType instead of a #GDBusConnection.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See dbus_session_proxy_new_for_bus() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type DBusSessionProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusSession *
dbus_session_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (DBUS_TYPE_SESSION_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.Session", NULL);
  if (ret != NULL)
    return DBUS_SESSION (ret);
  else
    return NULL;
}


/* ------------------------------------------------------------------------ */

/**
 * DBusSessionSkeleton:
 *
 * The #DBusSessionSkeleton structure contains only private data and should only be accessed using the provided API.
 */

/**
 * DBusSessionSkeletonClass:
 * @parent_class: The parent class.
 *
 * Class structure for #DBusSessionSkeleton.
 */

struct _DBusSessionSkeletonPrivate
{
  GValue *properties;
  GList *changed_properties;
  GSource *changed_properties_idle_source;
  GMainContext *context;
  GMutex lock;
};

static void
_dbus_session_skeleton_handle_method_call (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name,
  const gchar *method_name,
  GVariant *parameters,
  GDBusMethodInvocation *invocation,
  gpointer user_data)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (user_data);
  _ExtendedGDBusMethodInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  guint num_extra;
  gsize n;
  guint signal_id;
  GValue return_value = G_VALUE_INIT;
  info = (_ExtendedGDBusMethodInfo *) g_dbus_method_invocation_get_method_info (invocation);
  g_assert (info != NULL);
  num_params = g_variant_n_children (parameters);
  num_extra = info->pass_fdlist ? 3 : 2;  paramv = g_new0 (GValue, num_params + num_extra);
  n = 0;
  g_value_init (&paramv[n], DBUS_TYPE_SESSION);
  g_value_set_object (&paramv[n++], skeleton);
  g_value_init (&paramv[n], G_TYPE_DBUS_METHOD_INVOCATION);
  g_value_set_object (&paramv[n++], invocation);
  if (info->pass_fdlist)
    {
#ifdef G_OS_UNIX
      g_value_init (&paramv[n], G_TYPE_UNIX_FD_LIST);
      g_value_set_object (&paramv[n++], g_dbus_message_get_unix_fd_list (g_dbus_method_invocation_get_message (invocation)));
#else
      g_assert_not_reached ();
#endif
    }
  g_variant_iter_init (&iter, parameters);
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.in_args[n - num_extra];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, DBUS_TYPE_SESSION);
  g_value_init (&return_value, G_TYPE_BOOLEAN);
  g_signal_emitv (paramv, signal_id, 0, &return_value);
  if (!g_value_get_boolean (&return_value))
    g_dbus_method_invocation_return_error (invocation, G_DBUS_ERROR, G_DBUS_ERROR_UNKNOWN_METHOD, "Method %s is not implemented on interface %s", method_name, interface_name);
  g_value_unset (&return_value);
  for (n = 0; n < num_params + num_extra; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static GVariant *
_dbus_session_skeleton_handle_get_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GError **error,
  gpointer user_data)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  GVariant *ret;
  ret = NULL;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_session_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      g_value_init (&value, pspec->value_type);
      g_object_get_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      ret = g_dbus_gvalue_to_gvariant (&value, G_VARIANT_TYPE (info->parent_struct.signature));
      g_value_unset (&value);
    }
  return ret;
}

static gboolean
_dbus_session_skeleton_handle_set_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GVariant *variant,
  GError **error,
  gpointer user_data)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  gboolean ret;
  ret = FALSE;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_session_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      if (info->use_gvariant)
        g_value_set_variant (&value, variant);
      else
        g_dbus_gvariant_to_gvalue (variant, &value);
      g_object_set_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      g_value_unset (&value);
      ret = TRUE;
    }
  return ret;
}

static const GDBusInterfaceVTable _dbus_session_skeleton_vtable =
{
  _dbus_session_skeleton_handle_method_call,
  _dbus_session_skeleton_handle_get_property,
  _dbus_session_skeleton_handle_set_property,
  {NULL}
};

static GDBusInterfaceInfo *
dbus_session_skeleton_dbus_interface_get_info (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return dbus_session_interface_info ();
}

static GDBusInterfaceVTable *
dbus_session_skeleton_dbus_interface_get_vtable (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return (GDBusInterfaceVTable *) &_dbus_session_skeleton_vtable;
}

static GVariant *
dbus_session_skeleton_dbus_interface_get_properties (GDBusInterfaceSkeleton *_skeleton)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (_skeleton);

  GVariantBuilder builder;
  guint n;
  g_variant_builder_init (&builder, G_VARIANT_TYPE ("a{sv}"));
  if (_dbus_session_interface_info.parent_struct.properties == NULL)
    goto out;
  for (n = 0; _dbus_session_interface_info.parent_struct.properties[n] != NULL; n++)
    {
      GDBusPropertyInfo *info = _dbus_session_interface_info.parent_struct.properties[n];
      if (info->flags & G_DBUS_PROPERTY_INFO_FLAGS_READABLE)
        {
          GVariant *value;
          value = _dbus_session_skeleton_handle_get_property (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)), NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", info->name, NULL, skeleton);
          if (value != NULL)
            {
              g_variant_take_ref (value);
              g_variant_builder_add (&builder, "{sv}", info->name, value);
              g_variant_unref (value);
            }
        }
    }
out:
  return g_variant_builder_end (&builder);
}

static gboolean _dbus_session_emit_changed (gpointer user_data);

static void
dbus_session_skeleton_dbus_interface_flush (GDBusInterfaceSkeleton *_skeleton)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (_skeleton);
  gboolean emit_changed = FALSE;

  g_mutex_lock (&skeleton->priv->lock);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    {
      g_source_destroy (skeleton->priv->changed_properties_idle_source);
      skeleton->priv->changed_properties_idle_source = NULL;
      emit_changed = TRUE;
    }
  g_mutex_unlock (&skeleton->priv->lock);

  if (emit_changed)
    _dbus_session_emit_changed (skeleton);
}

static void
_dbus_session_on_signal_lock (
    DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "Lock",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_unlock (
    DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "Unlock",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_idle (
    DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "Idle",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_active (
    DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("()"));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "Active",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_inactive (
    DBusSession *object,
    guint arg_seconds)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(u)",
                   arg_seconds));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "Inactive",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_prepare_for_sleep (
    DBusSession *object,
    gboolean arg_state)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(b)",
                   arg_state));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "PrepareForSleep",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_prepare_for_shutdown (
    DBusSession *object,
    gboolean arg_state)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(b)",
                   arg_state));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "PrepareForShutdown",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_add_backlight (
    DBusSession *object,
    const gchar *arg_path)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(o)",
                   arg_path));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "AddBacklight",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_remove_backlight (
    DBusSession *object,
    const gchar *arg_path)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(o)",
                   arg_path));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "RemoveBacklight",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_add_audio_sink (
    DBusSession *object,
    const gchar *arg_path)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(o)",
                   arg_path));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "AddAudioSink",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_remove_audio_sink (
    DBusSession *object,
    const gchar *arg_path)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(o)",
                   arg_path));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "RemoveAudioSink",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_session_on_signal_change_default_audio_sink (
    DBusSession *object,
    const gchar *arg_path)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(o)",
                   arg_path));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Session", "ChangeDefaultAudioSink",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void dbus_session_skeleton_iface_init (DBusSessionIface *iface);
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (DBusSessionSkeleton, dbus_session_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_ADD_PRIVATE (DBusSessionSkeleton)
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_SESSION, dbus_session_skeleton_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (DBusSessionSkeleton, dbus_session_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_SESSION, dbus_session_skeleton_iface_init))

#endif
static void
dbus_session_skeleton_finalize (GObject *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  guint n;
  for (n = 0; n < 9; n++)
    g_value_unset (&skeleton->priv->properties[n]);
  g_free (skeleton->priv->properties);
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    g_source_destroy (skeleton->priv->changed_properties_idle_source);
  g_main_context_unref (skeleton->priv->context);
  g_mutex_clear (&skeleton->priv->lock);
  G_OBJECT_CLASS (dbus_session_skeleton_parent_class)->finalize (object);
}

static void
dbus_session_skeleton_get_property (GObject      *object,
  guint         prop_id,
  GValue       *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  g_assert (prop_id != 0 && prop_id - 1 < 9);
  g_mutex_lock (&skeleton->priv->lock);
  g_value_copy (&skeleton->priv->properties[prop_id - 1], value);
  g_mutex_unlock (&skeleton->priv->lock);
}

static gboolean
_dbus_session_emit_changed (gpointer user_data)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (user_data);
  GList *l;
  GVariantBuilder builder;
  GVariantBuilder invalidated_builder;
  guint num_changes;

  g_mutex_lock (&skeleton->priv->lock);
  g_variant_builder_init (&builder, G_VARIANT_TYPE ("a{sv}"));
  g_variant_builder_init (&invalidated_builder, G_VARIANT_TYPE ("as"));
  for (l = skeleton->priv->changed_properties, num_changes = 0; l != NULL; l = l->next)
    {
      ChangedProperty *cp = l->data;
      GVariant *variant;
      const GValue *cur_value;

      cur_value = &skeleton->priv->properties[cp->prop_id - 1];
      if (!_g_value_equal (cur_value, &cp->orig_value))
        {
          variant = g_dbus_gvalue_to_gvariant (cur_value, G_VARIANT_TYPE (cp->info->parent_struct.signature));
          g_variant_builder_add (&builder, "{sv}", cp->info->parent_struct.name, variant);
          g_variant_unref (variant);
          num_changes++;
        }
    }
  if (num_changes > 0)
    {
      GList *connections, *ll;
      GVariant *signal_variant;
      signal_variant = g_variant_ref_sink (g_variant_new ("(sa{sv}as)", "org.sessiond.session1.Session",
                                           &builder, &invalidated_builder));
      connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));
      for (ll = connections; ll != NULL; ll = ll->next)
        {
          GDBusConnection *connection = ll->data;

          g_dbus_connection_emit_signal (connection,
                                         NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)),
                                         "org.freedesktop.DBus.Properties",
                                         "PropertiesChanged",
                                         signal_variant,
                                         NULL);
        }
      g_variant_unref (signal_variant);
      g_list_free_full (connections, g_object_unref);
    }
  else
    {
      g_variant_builder_clear (&builder);
      g_variant_builder_clear (&invalidated_builder);
    }
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  skeleton->priv->changed_properties = NULL;
  skeleton->priv->changed_properties_idle_source = NULL;
  g_mutex_unlock (&skeleton->priv->lock);
  return FALSE;
}

static void
_dbus_session_schedule_emit_changed (DBusSessionSkeleton *skeleton, const _ExtendedGDBusPropertyInfo *info, guint prop_id, const GValue *orig_value)
{
  ChangedProperty *cp;
  GList *l;
  cp = NULL;
  for (l = skeleton->priv->changed_properties; l != NULL; l = l->next)
    {
      ChangedProperty *i_cp = l->data;
      if (i_cp->info == info)
        {
          cp = i_cp;
          break;
        }
    }
  if (cp == NULL)
    {
      cp = g_new0 (ChangedProperty, 1);
      cp->prop_id = prop_id;
      cp->info = info;
      skeleton->priv->changed_properties = g_list_prepend (skeleton->priv->changed_properties, cp);
      g_value_init (&cp->orig_value, G_VALUE_TYPE (orig_value));
      g_value_copy (orig_value, &cp->orig_value);
    }
}

static void
dbus_session_skeleton_notify (GObject      *object,
  GParamSpec *pspec G_GNUC_UNUSED)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  g_mutex_lock (&skeleton->priv->lock);
  if (skeleton->priv->changed_properties != NULL &&
      skeleton->priv->changed_properties_idle_source == NULL)
    {
      skeleton->priv->changed_properties_idle_source = g_idle_source_new ();
      g_source_set_priority (skeleton->priv->changed_properties_idle_source, G_PRIORITY_DEFAULT);
      g_source_set_callback (skeleton->priv->changed_properties_idle_source, _dbus_session_emit_changed, g_object_ref (skeleton), (GDestroyNotify) g_object_unref);
      g_source_set_name (skeleton->priv->changed_properties_idle_source, "[generated] _dbus_session_emit_changed");
      g_source_attach (skeleton->priv->changed_properties_idle_source, skeleton->priv->context);
      g_source_unref (skeleton->priv->changed_properties_idle_source);
    }
  g_mutex_unlock (&skeleton->priv->lock);
}

static void
dbus_session_skeleton_set_property (GObject      *object,
  guint         prop_id,
  const GValue *value,
  GParamSpec   *pspec)
{
  const _ExtendedGDBusPropertyInfo *info;
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  g_assert (prop_id != 0 && prop_id - 1 < 9);
  info = (const _ExtendedGDBusPropertyInfo *) _dbus_session_property_info_pointers[prop_id - 1];
  g_mutex_lock (&skeleton->priv->lock);
  g_object_freeze_notify (object);
  if (!_g_value_equal (value, &skeleton->priv->properties[prop_id - 1]))
    {
      if (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)) != NULL &&
          info->emits_changed_signal)
        _dbus_session_schedule_emit_changed (skeleton, info, prop_id, &skeleton->priv->properties[prop_id - 1]);
      g_value_copy (value, &skeleton->priv->properties[prop_id - 1]);
      g_object_notify_by_pspec (object, pspec);
    }
  g_mutex_unlock (&skeleton->priv->lock);
  g_object_thaw_notify (object);
}

static void
dbus_session_skeleton_init (DBusSessionSkeleton *skeleton)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  skeleton->priv = dbus_session_skeleton_get_instance_private (skeleton);
#else
  skeleton->priv = G_TYPE_INSTANCE_GET_PRIVATE (skeleton, DBUS_TYPE_SESSION_SKELETON, DBusSessionSkeletonPrivate);
#endif

  g_mutex_init (&skeleton->priv->lock);
  skeleton->priv->context = g_main_context_ref_thread_default ();
  skeleton->priv->properties = g_new0 (GValue, 9);
  g_value_init (&skeleton->priv->properties[0], G_TYPE_BOOLEAN);
  g_value_init (&skeleton->priv->properties[1], G_TYPE_BOOLEAN);
  g_value_init (&skeleton->priv->properties[2], G_TYPE_BOOLEAN);
  g_value_init (&skeleton->priv->properties[3], G_TYPE_UINT64);
  g_value_init (&skeleton->priv->properties[4], G_TYPE_UINT64);
  g_value_init (&skeleton->priv->properties[5], G_TYPE_STRV);
  g_value_init (&skeleton->priv->properties[6], G_TYPE_STRV);
  g_value_init (&skeleton->priv->properties[7], G_TYPE_STRING);
  g_value_init (&skeleton->priv->properties[8], G_TYPE_STRING);
}

static gboolean 
dbus_session_skeleton_get_inhibited_hint (DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  gboolean value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_boolean (&(skeleton->priv->properties[0]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static gboolean 
dbus_session_skeleton_get_locked_hint (DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  gboolean value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_boolean (&(skeleton->priv->properties[1]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static gboolean 
dbus_session_skeleton_get_idle_hint (DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  gboolean value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_boolean (&(skeleton->priv->properties[2]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static guint64 
dbus_session_skeleton_get_idle_since_hint (DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  guint64 value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_uint64 (&(skeleton->priv->properties[3]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static guint64 
dbus_session_skeleton_get_idle_since_hint_monotonic (DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  guint64 value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_uint64 (&(skeleton->priv->properties[4]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static const gchar *const *
dbus_session_skeleton_get_backlights (DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  const gchar *const *value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_boxed (&(skeleton->priv->properties[5]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static const gchar *const *
dbus_session_skeleton_get_audio_sinks (DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  const gchar *const *value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_boxed (&(skeleton->priv->properties[6]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static const gchar *
dbus_session_skeleton_get_default_audio_sink (DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  const gchar *value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_string (&(skeleton->priv->properties[7]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static const gchar *
dbus_session_skeleton_get_version (DBusSession *object)
{
  DBusSessionSkeleton *skeleton = DBUS_SESSION_SKELETON (object);
  const gchar *value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_string (&(skeleton->priv->properties[8]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static void
dbus_session_skeleton_class_init (DBusSessionSkeletonClass *klass)
{
  GObjectClass *gobject_class;
  GDBusInterfaceSkeletonClass *skeleton_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize = dbus_session_skeleton_finalize;
  gobject_class->get_property = dbus_session_skeleton_get_property;
  gobject_class->set_property = dbus_session_skeleton_set_property;
  gobject_class->notify       = dbus_session_skeleton_notify;


  dbus_session_override_properties (gobject_class, 1);

  skeleton_class = G_DBUS_INTERFACE_SKELETON_CLASS (klass);
  skeleton_class->get_info = dbus_session_skeleton_dbus_interface_get_info;
  skeleton_class->get_properties = dbus_session_skeleton_dbus_interface_get_properties;
  skeleton_class->flush = dbus_session_skeleton_dbus_interface_flush;
  skeleton_class->get_vtable = dbus_session_skeleton_dbus_interface_get_vtable;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (DBusSessionSkeletonPrivate));
#endif
}

static void
dbus_session_skeleton_iface_init (DBusSessionIface *iface)
{
  iface->lock = _dbus_session_on_signal_lock;
  iface->unlock = _dbus_session_on_signal_unlock;
  iface->idle = _dbus_session_on_signal_idle;
  iface->active = _dbus_session_on_signal_active;
  iface->inactive = _dbus_session_on_signal_inactive;
  iface->prepare_for_sleep = _dbus_session_on_signal_prepare_for_sleep;
  iface->prepare_for_shutdown = _dbus_session_on_signal_prepare_for_shutdown;
  iface->add_backlight = _dbus_session_on_signal_add_backlight;
  iface->remove_backlight = _dbus_session_on_signal_remove_backlight;
  iface->add_audio_sink = _dbus_session_on_signal_add_audio_sink;
  iface->remove_audio_sink = _dbus_session_on_signal_remove_audio_sink;
  iface->change_default_audio_sink = _dbus_session_on_signal_change_default_audio_sink;
  iface->get_inhibited_hint = dbus_session_skeleton_get_inhibited_hint;
  iface->get_locked_hint = dbus_session_skeleton_get_locked_hint;
  iface->get_idle_hint = dbus_session_skeleton_get_idle_hint;
  iface->get_idle_since_hint = dbus_session_skeleton_get_idle_since_hint;
  iface->get_idle_since_hint_monotonic = dbus_session_skeleton_get_idle_since_hint_monotonic;
  iface->get_backlights = dbus_session_skeleton_get_backlights;
  iface->get_audio_sinks = dbus_session_skeleton_get_audio_sinks;
  iface->get_default_audio_sink = dbus_session_skeleton_get_default_audio_sink;
  iface->get_version = dbus_session_skeleton_get_version;
}

/**
 * dbus_session_skeleton_new:
 *
 * Creates a skeleton object for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Session.top_of_page">org.sessiond.session1.Session</link>.
 *
 * Returns: (transfer full) (type DBusSessionSkeleton): The skeleton object.
 */
DBusSession *
dbus_session_skeleton_new (void)
{
  return DBUS_SESSION (g_object_new (DBUS_TYPE_SESSION_SKELETON, NULL));
}

/* ------------------------------------------------------------------------
 * Code for interface org.sessiond.session1.Backlight
 * ------------------------------------------------------------------------
 */

/**
 * SECTION:DBusBacklight
 * @title: DBusBacklight
 * @short_description: Generated C code for the org.sessiond.session1.Backlight D-Bus interface
 *
 * This section contains code for working with the <link linkend="gdbus-interface-org-sessiond-session1-Backlight.top_of_page">org.sessiond.session1.Backlight</link> D-Bus interface in C.
 */

/* ---- Introspection data for org.sessiond.session1.Backlight ---- */

static const _ExtendedGDBusArgInfo _dbus_backlight_method_info_set_brightness_IN_ARG_brightness =
{
  {
    -1,
    (gchar *) "brightness",
    (gchar *) "u",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_backlight_method_info_set_brightness_IN_ARG_pointers[] =
{
  &_dbus_backlight_method_info_set_brightness_IN_ARG_brightness.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_backlight_method_info_set_brightness =
{
  {
    -1,
    (gchar *) "SetBrightness",
    (GDBusArgInfo **) &_dbus_backlight_method_info_set_brightness_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-set-brightness",
  FALSE
};

static const _ExtendedGDBusArgInfo _dbus_backlight_method_info_inc_brightness_IN_ARG_value =
{
  {
    -1,
    (gchar *) "value",
    (gchar *) "i",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_backlight_method_info_inc_brightness_IN_ARG_pointers[] =
{
  &_dbus_backlight_method_info_inc_brightness_IN_ARG_value.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _dbus_backlight_method_info_inc_brightness_OUT_ARG_brightness =
{
  {
    -1,
    (gchar *) "brightness",
    (gchar *) "u",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_backlight_method_info_inc_brightness_OUT_ARG_pointers[] =
{
  &_dbus_backlight_method_info_inc_brightness_OUT_ARG_brightness.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_backlight_method_info_inc_brightness =
{
  {
    -1,
    (gchar *) "IncBrightness",
    (GDBusArgInfo **) &_dbus_backlight_method_info_inc_brightness_IN_ARG_pointers,
    (GDBusArgInfo **) &_dbus_backlight_method_info_inc_brightness_OUT_ARG_pointers,
    NULL
  },
  "handle-inc-brightness",
  FALSE
};

static const GDBusMethodInfo * const _dbus_backlight_method_info_pointers[] =
{
  &_dbus_backlight_method_info_set_brightness.parent_struct,
  &_dbus_backlight_method_info_inc_brightness.parent_struct,
  NULL
};

static const _ExtendedGDBusPropertyInfo _dbus_backlight_property_info_online =
{
  {
    -1,
    (gchar *) "Online",
    (gchar *) "b",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "online",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_backlight_property_info_name =
{
  {
    -1,
    (gchar *) "Name",
    (gchar *) "s",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "name",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_backlight_property_info_subsystem =
{
  {
    -1,
    (gchar *) "Subsystem",
    (gchar *) "s",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "subsystem",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_backlight_property_info_sys_path =
{
  {
    -1,
    (gchar *) "SysPath",
    (gchar *) "s",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "sys-path",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_backlight_property_info_dev_path =
{
  {
    -1,
    (gchar *) "DevPath",
    (gchar *) "s",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "dev-path",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_backlight_property_info_max_brightness =
{
  {
    -1,
    (gchar *) "MaxBrightness",
    (gchar *) "u",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "max-brightness",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_backlight_property_info_brightness =
{
  {
    -1,
    (gchar *) "Brightness",
    (gchar *) "u",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "brightness",
  FALSE,
  TRUE
};

static const GDBusPropertyInfo * const _dbus_backlight_property_info_pointers[] =
{
  &_dbus_backlight_property_info_online.parent_struct,
  &_dbus_backlight_property_info_name.parent_struct,
  &_dbus_backlight_property_info_subsystem.parent_struct,
  &_dbus_backlight_property_info_sys_path.parent_struct,
  &_dbus_backlight_property_info_dev_path.parent_struct,
  &_dbus_backlight_property_info_max_brightness.parent_struct,
  &_dbus_backlight_property_info_brightness.parent_struct,
  NULL
};

static const _ExtendedGDBusInterfaceInfo _dbus_backlight_interface_info =
{
  {
    -1,
    (gchar *) "org.sessiond.session1.Backlight",
    (GDBusMethodInfo **) &_dbus_backlight_method_info_pointers,
    NULL,
    (GDBusPropertyInfo **) &_dbus_backlight_property_info_pointers,
    NULL
  },
  "backlight",
};


/**
 * dbus_backlight_interface_info:
 *
 * Gets a machine-readable description of the <link linkend="gdbus-interface-org-sessiond-session1-Backlight.top_of_page">org.sessiond.session1.Backlight</link> D-Bus interface.
 *
 * Returns: (transfer none): A #GDBusInterfaceInfo. Do not free.
 */
GDBusInterfaceInfo *
dbus_backlight_interface_info (void)
{
  return (GDBusInterfaceInfo *) &_dbus_backlight_interface_info.parent_struct;
}

/**
 * dbus_backlight_override_properties:
 * @klass: The class structure for a #GObject derived class.
 * @property_id_begin: The property id to assign to the first overridden property.
 *
 * Overrides all #GObject properties in the #DBusBacklight interface for a concrete class.
 * The properties are overridden in the order they are defined.
 *
 * Returns: The last property id.
 */
guint
dbus_backlight_override_properties (GObjectClass *klass, guint property_id_begin)
{
  g_object_class_override_property (klass, property_id_begin++, "online");
  g_object_class_override_property (klass, property_id_begin++, "name");
  g_object_class_override_property (klass, property_id_begin++, "subsystem");
  g_object_class_override_property (klass, property_id_begin++, "sys-path");
  g_object_class_override_property (klass, property_id_begin++, "dev-path");
  g_object_class_override_property (klass, property_id_begin++, "max-brightness");
  g_object_class_override_property (klass, property_id_begin++, "brightness");
  return property_id_begin - 1;
}



/**
 * DBusBacklight:
 *
 * Abstract interface type for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Backlight.top_of_page">org.sessiond.session1.Backlight</link>.
 */

/**
 * DBusBacklightIface:
 * @parent_iface: The parent interface.
 * @handle_inc_brightness: Handler for the #DBusBacklight::handle-inc-brightness signal.
 * @handle_set_brightness: Handler for the #DBusBacklight::handle-set-brightness signal.
 * @get_brightness: Getter for the #DBusBacklight:brightness property.
 * @get_dev_path: Getter for the #DBusBacklight:dev-path property.
 * @get_max_brightness: Getter for the #DBusBacklight:max-brightness property.
 * @get_name: Getter for the #DBusBacklight:name property.
 * @get_online: Getter for the #DBusBacklight:online property.
 * @get_subsystem: Getter for the #DBusBacklight:subsystem property.
 * @get_sys_path: Getter for the #DBusBacklight:sys-path property.
 *
 * Virtual table for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Backlight.top_of_page">org.sessiond.session1.Backlight</link>.
 */

typedef DBusBacklightIface DBusBacklightInterface;
G_DEFINE_INTERFACE (DBusBacklight, dbus_backlight, G_TYPE_OBJECT)

static void
dbus_backlight_default_init (DBusBacklightIface *iface)
{
  /* GObject signals for incoming D-Bus method calls: */
  /**
   * DBusBacklight::handle-set-brightness:
   * @object: A #DBusBacklight.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_brightness: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-Backlight.SetBrightness">SetBrightness()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_backlight_complete_set_brightness() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-set-brightness",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusBacklightIface, handle_set_brightness),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_UINT);

  /**
   * DBusBacklight::handle-inc-brightness:
   * @object: A #DBusBacklight.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_value: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-Backlight.IncBrightness">IncBrightness()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_backlight_complete_inc_brightness() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-inc-brightness",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusBacklightIface, handle_inc_brightness),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_INT);

  /* GObject properties for D-Bus properties: */
  /**
   * DBusBacklight:online:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Backlight.Online">"Online"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_boolean ("online", "Online", "Online", FALSE, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusBacklight:name:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Backlight.Name">"Name"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_string ("name", "Name", "Name", NULL, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusBacklight:subsystem:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Backlight.Subsystem">"Subsystem"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_string ("subsystem", "Subsystem", "Subsystem", NULL, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusBacklight:sys-path:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Backlight.SysPath">"SysPath"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_string ("sys-path", "SysPath", "SysPath", NULL, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusBacklight:dev-path:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Backlight.DevPath">"DevPath"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_string ("dev-path", "DevPath", "DevPath", NULL, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusBacklight:max-brightness:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Backlight.MaxBrightness">"MaxBrightness"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_uint ("max-brightness", "MaxBrightness", "MaxBrightness", 0, G_MAXUINT32, 0, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusBacklight:brightness:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-Backlight.Brightness">"Brightness"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_uint ("brightness", "Brightness", "Brightness", 0, G_MAXUINT32, 0, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
}

/**
 * dbus_backlight_get_online: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Online">"Online"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
gboolean 
dbus_backlight_get_online (DBusBacklight *object)
{
  return DBUS_BACKLIGHT_GET_IFACE (object)->get_online (object);
}

/**
 * dbus_backlight_set_online: (skip)
 * @object: A #DBusBacklight.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Online">"Online"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_backlight_set_online (DBusBacklight *object, gboolean value)
{
  g_object_set (G_OBJECT (object), "online", value, NULL);
}

/**
 * dbus_backlight_get_name: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Name">"Name"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where @object was constructed. Use dbus_backlight_dup_name() if on another thread.
 *
 * Returns: (transfer none) (nullable): The property value or %NULL if the property is not set. Do not free the returned value, it belongs to @object.
 */
const gchar *
dbus_backlight_get_name (DBusBacklight *object)
{
  return DBUS_BACKLIGHT_GET_IFACE (object)->get_name (object);
}

/**
 * dbus_backlight_dup_name: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets a copy of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Name">"Name"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: (transfer full) (nullable): The property value or %NULL if the property is not set. The returned value should be freed with g_free().
 */
gchar *
dbus_backlight_dup_name (DBusBacklight *object)
{
  gchar *value;
  g_object_get (G_OBJECT (object), "name", &value, NULL);
  return value;
}

/**
 * dbus_backlight_set_name: (skip)
 * @object: A #DBusBacklight.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Name">"Name"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_backlight_set_name (DBusBacklight *object, const gchar *value)
{
  g_object_set (G_OBJECT (object), "name", value, NULL);
}

/**
 * dbus_backlight_get_subsystem: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Subsystem">"Subsystem"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where @object was constructed. Use dbus_backlight_dup_subsystem() if on another thread.
 *
 * Returns: (transfer none) (nullable): The property value or %NULL if the property is not set. Do not free the returned value, it belongs to @object.
 */
const gchar *
dbus_backlight_get_subsystem (DBusBacklight *object)
{
  return DBUS_BACKLIGHT_GET_IFACE (object)->get_subsystem (object);
}

/**
 * dbus_backlight_dup_subsystem: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets a copy of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Subsystem">"Subsystem"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: (transfer full) (nullable): The property value or %NULL if the property is not set. The returned value should be freed with g_free().
 */
gchar *
dbus_backlight_dup_subsystem (DBusBacklight *object)
{
  gchar *value;
  g_object_get (G_OBJECT (object), "subsystem", &value, NULL);
  return value;
}

/**
 * dbus_backlight_set_subsystem: (skip)
 * @object: A #DBusBacklight.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Subsystem">"Subsystem"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_backlight_set_subsystem (DBusBacklight *object, const gchar *value)
{
  g_object_set (G_OBJECT (object), "subsystem", value, NULL);
}

/**
 * dbus_backlight_get_sys_path: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.SysPath">"SysPath"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where @object was constructed. Use dbus_backlight_dup_sys_path() if on another thread.
 *
 * Returns: (transfer none) (nullable): The property value or %NULL if the property is not set. Do not free the returned value, it belongs to @object.
 */
const gchar *
dbus_backlight_get_sys_path (DBusBacklight *object)
{
  return DBUS_BACKLIGHT_GET_IFACE (object)->get_sys_path (object);
}

/**
 * dbus_backlight_dup_sys_path: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets a copy of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.SysPath">"SysPath"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: (transfer full) (nullable): The property value or %NULL if the property is not set. The returned value should be freed with g_free().
 */
gchar *
dbus_backlight_dup_sys_path (DBusBacklight *object)
{
  gchar *value;
  g_object_get (G_OBJECT (object), "sys-path", &value, NULL);
  return value;
}

/**
 * dbus_backlight_set_sys_path: (skip)
 * @object: A #DBusBacklight.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Backlight.SysPath">"SysPath"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_backlight_set_sys_path (DBusBacklight *object, const gchar *value)
{
  g_object_set (G_OBJECT (object), "sys-path", value, NULL);
}

/**
 * dbus_backlight_get_dev_path: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.DevPath">"DevPath"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where @object was constructed. Use dbus_backlight_dup_dev_path() if on another thread.
 *
 * Returns: (transfer none) (nullable): The property value or %NULL if the property is not set. Do not free the returned value, it belongs to @object.
 */
const gchar *
dbus_backlight_get_dev_path (DBusBacklight *object)
{
  return DBUS_BACKLIGHT_GET_IFACE (object)->get_dev_path (object);
}

/**
 * dbus_backlight_dup_dev_path: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets a copy of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.DevPath">"DevPath"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: (transfer full) (nullable): The property value or %NULL if the property is not set. The returned value should be freed with g_free().
 */
gchar *
dbus_backlight_dup_dev_path (DBusBacklight *object)
{
  gchar *value;
  g_object_get (G_OBJECT (object), "dev-path", &value, NULL);
  return value;
}

/**
 * dbus_backlight_set_dev_path: (skip)
 * @object: A #DBusBacklight.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Backlight.DevPath">"DevPath"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_backlight_set_dev_path (DBusBacklight *object, const gchar *value)
{
  g_object_set (G_OBJECT (object), "dev-path", value, NULL);
}

/**
 * dbus_backlight_get_max_brightness: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.MaxBrightness">"MaxBrightness"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
guint 
dbus_backlight_get_max_brightness (DBusBacklight *object)
{
  return DBUS_BACKLIGHT_GET_IFACE (object)->get_max_brightness (object);
}

/**
 * dbus_backlight_set_max_brightness: (skip)
 * @object: A #DBusBacklight.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Backlight.MaxBrightness">"MaxBrightness"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_backlight_set_max_brightness (DBusBacklight *object, guint value)
{
  g_object_set (G_OBJECT (object), "max-brightness", value, NULL);
}

/**
 * dbus_backlight_get_brightness: (skip)
 * @object: A #DBusBacklight.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Brightness">"Brightness"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
guint 
dbus_backlight_get_brightness (DBusBacklight *object)
{
  return DBUS_BACKLIGHT_GET_IFACE (object)->get_brightness (object);
}

/**
 * dbus_backlight_set_brightness: (skip)
 * @object: A #DBusBacklight.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-Backlight.Brightness">"Brightness"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_backlight_set_brightness (DBusBacklight *object, guint value)
{
  g_object_set (G_OBJECT (object), "brightness", value, NULL);
}

/**
 * dbus_backlight_call_set_brightness:
 * @proxy: A #DBusBacklightProxy.
 * @arg_brightness: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Backlight.SetBrightness">SetBrightness()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_backlight_call_set_brightness_finish() to get the result of the operation.
 *
 * See dbus_backlight_call_set_brightness_sync() for the synchronous, blocking version of this method.
 */
void
dbus_backlight_call_set_brightness (
    DBusBacklight *proxy,
    guint arg_brightness,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "SetBrightness",
    g_variant_new ("(u)",
                   arg_brightness),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_backlight_call_set_brightness_finish:
 * @proxy: A #DBusBacklightProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_backlight_call_set_brightness().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_backlight_call_set_brightness().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_backlight_call_set_brightness_finish (
    DBusBacklight *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_backlight_call_set_brightness_sync:
 * @proxy: A #DBusBacklightProxy.
 * @arg_brightness: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Backlight.SetBrightness">SetBrightness()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_backlight_call_set_brightness() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_backlight_call_set_brightness_sync (
    DBusBacklight *proxy,
    guint arg_brightness,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "SetBrightness",
    g_variant_new ("(u)",
                   arg_brightness),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_backlight_call_inc_brightness:
 * @proxy: A #DBusBacklightProxy.
 * @arg_value: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Backlight.IncBrightness">IncBrightness()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_backlight_call_inc_brightness_finish() to get the result of the operation.
 *
 * See dbus_backlight_call_inc_brightness_sync() for the synchronous, blocking version of this method.
 */
void
dbus_backlight_call_inc_brightness (
    DBusBacklight *proxy,
    gint arg_value,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "IncBrightness",
    g_variant_new ("(i)",
                   arg_value),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_backlight_call_inc_brightness_finish:
 * @proxy: A #DBusBacklightProxy.
 * @out_brightness: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_backlight_call_inc_brightness().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_backlight_call_inc_brightness().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_backlight_call_inc_brightness_finish (
    DBusBacklight *proxy,
    guint *out_brightness,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(u)",
                 out_brightness);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_backlight_call_inc_brightness_sync:
 * @proxy: A #DBusBacklightProxy.
 * @arg_value: Argument to pass with the method invocation.
 * @out_brightness: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-Backlight.IncBrightness">IncBrightness()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_backlight_call_inc_brightness() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_backlight_call_inc_brightness_sync (
    DBusBacklight *proxy,
    gint arg_value,
    guint *out_brightness,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "IncBrightness",
    g_variant_new ("(i)",
                   arg_value),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(u)",
                 out_brightness);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_backlight_complete_set_brightness:
 * @object: A #DBusBacklight.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-Backlight.SetBrightness">SetBrightness()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_backlight_complete_set_brightness (
    DBusBacklight *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * dbus_backlight_complete_inc_brightness:
 * @object: A #DBusBacklight.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @brightness: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-Backlight.IncBrightness">IncBrightness()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_backlight_complete_inc_brightness (
    DBusBacklight *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    guint brightness)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(u)",
                   brightness));
}

/* ------------------------------------------------------------------------ */

/**
 * DBusBacklightProxy:
 *
 * The #DBusBacklightProxy structure contains only private data and should only be accessed using the provided API.
 */

/**
 * DBusBacklightProxyClass:
 * @parent_class: The parent class.
 *
 * Class structure for #DBusBacklightProxy.
 */

struct _DBusBacklightProxyPrivate
{
  GData *qdata;
};

static void dbus_backlight_proxy_iface_init (DBusBacklightIface *iface);

#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (DBusBacklightProxy, dbus_backlight_proxy, G_TYPE_DBUS_PROXY,
                         G_ADD_PRIVATE (DBusBacklightProxy)
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_BACKLIGHT, dbus_backlight_proxy_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (DBusBacklightProxy, dbus_backlight_proxy, G_TYPE_DBUS_PROXY,
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_BACKLIGHT, dbus_backlight_proxy_iface_init))

#endif
static void
dbus_backlight_proxy_finalize (GObject *object)
{
  DBusBacklightProxy *proxy = DBUS_BACKLIGHT_PROXY (object);
  g_datalist_clear (&proxy->priv->qdata);
  G_OBJECT_CLASS (dbus_backlight_proxy_parent_class)->finalize (object);
}

static void
dbus_backlight_proxy_get_property (GObject      *object,
  guint         prop_id,
  GValue       *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
  const _ExtendedGDBusPropertyInfo *info;
  GVariant *variant;
  g_assert (prop_id != 0 && prop_id - 1 < 7);
  info = (const _ExtendedGDBusPropertyInfo *) _dbus_backlight_property_info_pointers[prop_id - 1];
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (object), info->parent_struct.name);
  if (info->use_gvariant)
    {
      g_value_set_variant (value, variant);
    }
  else
    {
      if (variant != NULL)
        g_dbus_gvariant_to_gvalue (variant, value);
    }
  if (variant != NULL)
    g_variant_unref (variant);
}

static void
dbus_backlight_proxy_set_property_cb (GDBusProxy *proxy,
  GAsyncResult *res,
  gpointer      user_data)
{
  const _ExtendedGDBusPropertyInfo *info = user_data;
  GError *error;
  GVariant *_ret;
  error = NULL;
  _ret = g_dbus_proxy_call_finish (proxy, res, &error);
  if (!_ret)
    {
      g_warning ("Error setting property '%s' on interface org.sessiond.session1.Backlight: %s (%s, %d)",
                 info->parent_struct.name, 
                 error->message, g_quark_to_string (error->domain), error->code);
      g_error_free (error);
    }
  else
    {
      g_variant_unref (_ret);
    }
}

static void
dbus_backlight_proxy_set_property (GObject      *object,
  guint         prop_id,
  const GValue *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
  const _ExtendedGDBusPropertyInfo *info;
  GVariant *variant;
  g_assert (prop_id != 0 && prop_id - 1 < 7);
  info = (const _ExtendedGDBusPropertyInfo *) _dbus_backlight_property_info_pointers[prop_id - 1];
  variant = g_dbus_gvalue_to_gvariant (value, G_VARIANT_TYPE (info->parent_struct.signature));
  g_dbus_proxy_call (G_DBUS_PROXY (object),
    "org.freedesktop.DBus.Properties.Set",
    g_variant_new ("(ssv)", "org.sessiond.session1.Backlight", info->parent_struct.name, variant),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    NULL, (GAsyncReadyCallback) dbus_backlight_proxy_set_property_cb, (GDBusPropertyInfo *) &info->parent_struct);
  g_variant_unref (variant);
}

static void
dbus_backlight_proxy_g_signal (GDBusProxy *proxy,
  const gchar *sender_name G_GNUC_UNUSED,
  const gchar *signal_name,
  GVariant *parameters)
{
  _ExtendedGDBusSignalInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  gsize n;
  guint signal_id;
  info = (_ExtendedGDBusSignalInfo *) g_dbus_interface_info_lookup_signal ((GDBusInterfaceInfo *) &_dbus_backlight_interface_info.parent_struct, signal_name);
  if (info == NULL)
    return;
  num_params = g_variant_n_children (parameters);
  paramv = g_new0 (GValue, num_params + 1);
  g_value_init (&paramv[0], DBUS_TYPE_BACKLIGHT);
  g_value_set_object (&paramv[0], proxy);
  g_variant_iter_init (&iter, parameters);
  n = 1;
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.args[n - 1];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, DBUS_TYPE_BACKLIGHT);
  g_signal_emitv (paramv, signal_id, 0, NULL);
  for (n = 0; n < num_params + 1; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static void
dbus_backlight_proxy_g_properties_changed (GDBusProxy *_proxy,
  GVariant *changed_properties,
  const gchar *const *invalidated_properties)
{
  DBusBacklightProxy *proxy = DBUS_BACKLIGHT_PROXY (_proxy);
  guint n;
  const gchar *key;
  GVariantIter *iter;
  _ExtendedGDBusPropertyInfo *info;
  g_variant_get (changed_properties, "a{sv}", &iter);
  while (g_variant_iter_next (iter, "{&sv}", &key, NULL))
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_backlight_interface_info.parent_struct, key);
      g_datalist_remove_data (&proxy->priv->qdata, key);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
  g_variant_iter_free (iter);
  for (n = 0; invalidated_properties[n] != NULL; n++)
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_backlight_interface_info.parent_struct, invalidated_properties[n]);
      g_datalist_remove_data (&proxy->priv->qdata, invalidated_properties[n]);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
}

static gboolean 
dbus_backlight_proxy_get_online (DBusBacklight *object)
{
  DBusBacklightProxy *proxy = DBUS_BACKLIGHT_PROXY (object);
  GVariant *variant;
  gboolean value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Online");
  if (variant != NULL)
    {
      value = g_variant_get_boolean (variant);
      g_variant_unref (variant);
    }
  return value;
}

static const gchar *
dbus_backlight_proxy_get_name (DBusBacklight *object)
{
  DBusBacklightProxy *proxy = DBUS_BACKLIGHT_PROXY (object);
  GVariant *variant;
  const gchar *value = NULL;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Name");
  if (variant != NULL)
    {
      value = g_variant_get_string (variant, NULL);
      g_variant_unref (variant);
    }
  return value;
}

static const gchar *
dbus_backlight_proxy_get_subsystem (DBusBacklight *object)
{
  DBusBacklightProxy *proxy = DBUS_BACKLIGHT_PROXY (object);
  GVariant *variant;
  const gchar *value = NULL;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Subsystem");
  if (variant != NULL)
    {
      value = g_variant_get_string (variant, NULL);
      g_variant_unref (variant);
    }
  return value;
}

static const gchar *
dbus_backlight_proxy_get_sys_path (DBusBacklight *object)
{
  DBusBacklightProxy *proxy = DBUS_BACKLIGHT_PROXY (object);
  GVariant *variant;
  const gchar *value = NULL;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "SysPath");
  if (variant != NULL)
    {
      value = g_variant_get_string (variant, NULL);
      g_variant_unref (variant);
    }
  return value;
}

static const gchar *
dbus_backlight_proxy_get_dev_path (DBusBacklight *object)
{
  DBusBacklightProxy *proxy = DBUS_BACKLIGHT_PROXY (object);
  GVariant *variant;
  const gchar *value = NULL;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "DevPath");
  if (variant != NULL)
    {
      value = g_variant_get_string (variant, NULL);
      g_variant_unref (variant);
    }
  return value;
}

static guint 
dbus_backlight_proxy_get_max_brightness (DBusBacklight *object)
{
  DBusBacklightProxy *proxy = DBUS_BACKLIGHT_PROXY (object);
  GVariant *variant;
  guint value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "MaxBrightness");
  if (variant != NULL)
    {
      value = g_variant_get_uint32 (variant);
      g_variant_unref (variant);
    }
  return value;
}

static guint 
dbus_backlight_proxy_get_brightness (DBusBacklight *object)
{
  DBusBacklightProxy *proxy = DBUS_BACKLIGHT_PROXY (object);
  GVariant *variant;
  guint value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Brightness");
  if (variant != NULL)
    {
      value = g_variant_get_uint32 (variant);
      g_variant_unref (variant);
    }
  return value;
}

static void
dbus_backlight_proxy_init (DBusBacklightProxy *proxy)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  proxy->priv = dbus_backlight_proxy_get_instance_private (proxy);
#else
  proxy->priv = G_TYPE_INSTANCE_GET_PRIVATE (proxy, DBUS_TYPE_BACKLIGHT_PROXY, DBusBacklightProxyPrivate);
#endif

  g_dbus_proxy_set_interface_info (G_DBUS_PROXY (proxy), dbus_backlight_interface_info ());
}

static void
dbus_backlight_proxy_class_init (DBusBacklightProxyClass *klass)
{
  GObjectClass *gobject_class;
  GDBusProxyClass *proxy_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize     = dbus_backlight_proxy_finalize;
  gobject_class->get_property = dbus_backlight_proxy_get_property;
  gobject_class->set_property = dbus_backlight_proxy_set_property;

  proxy_class = G_DBUS_PROXY_CLASS (klass);
  proxy_class->g_signal = dbus_backlight_proxy_g_signal;
  proxy_class->g_properties_changed = dbus_backlight_proxy_g_properties_changed;

  dbus_backlight_override_properties (gobject_class, 1);

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (DBusBacklightProxyPrivate));
#endif
}

static void
dbus_backlight_proxy_iface_init (DBusBacklightIface *iface)
{
  iface->get_online = dbus_backlight_proxy_get_online;
  iface->get_name = dbus_backlight_proxy_get_name;
  iface->get_subsystem = dbus_backlight_proxy_get_subsystem;
  iface->get_sys_path = dbus_backlight_proxy_get_sys_path;
  iface->get_dev_path = dbus_backlight_proxy_get_dev_path;
  iface->get_max_brightness = dbus_backlight_proxy_get_max_brightness;
  iface->get_brightness = dbus_backlight_proxy_get_brightness;
}

/**
 * dbus_backlight_proxy_new:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Backlight.top_of_page">org.sessiond.session1.Backlight</link>. See g_dbus_proxy_new() for more details.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_backlight_proxy_new_finish() to get the result of the operation.
 *
 * See dbus_backlight_proxy_new_sync() for the synchronous, blocking version of this constructor.
 */
void
dbus_backlight_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (DBUS_TYPE_BACKLIGHT_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.Backlight", NULL);
}

/**
 * dbus_backlight_proxy_new_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_backlight_proxy_new().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with dbus_backlight_proxy_new().
 *
 * Returns: (transfer full) (type DBusBacklightProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusBacklight *
dbus_backlight_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return DBUS_BACKLIGHT (ret);
  else
    return NULL;
}

/**
 * dbus_backlight_proxy_new_sync:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Synchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Backlight.top_of_page">org.sessiond.session1.Backlight</link>. See g_dbus_proxy_new_sync() for more details.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See dbus_backlight_proxy_new() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type DBusBacklightProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusBacklight *
dbus_backlight_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (DBUS_TYPE_BACKLIGHT_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.Backlight", NULL);
  if (ret != NULL)
    return DBUS_BACKLIGHT (ret);
  else
    return NULL;
}


/**
 * dbus_backlight_proxy_new_for_bus:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Like dbus_backlight_proxy_new() but takes a #GBusType instead of a #GDBusConnection.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_backlight_proxy_new_for_bus_finish() to get the result of the operation.
 *
 * See dbus_backlight_proxy_new_for_bus_sync() for the synchronous, blocking version of this constructor.
 */
void
dbus_backlight_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (DBUS_TYPE_BACKLIGHT_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.Backlight", NULL);
}

/**
 * dbus_backlight_proxy_new_for_bus_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_backlight_proxy_new_for_bus().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with dbus_backlight_proxy_new_for_bus().
 *
 * Returns: (transfer full) (type DBusBacklightProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusBacklight *
dbus_backlight_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return DBUS_BACKLIGHT (ret);
  else
    return NULL;
}

/**
 * dbus_backlight_proxy_new_for_bus_sync:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Like dbus_backlight_proxy_new_sync() but takes a #GBusType instead of a #GDBusConnection.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See dbus_backlight_proxy_new_for_bus() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type DBusBacklightProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusBacklight *
dbus_backlight_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (DBUS_TYPE_BACKLIGHT_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.Backlight", NULL);
  if (ret != NULL)
    return DBUS_BACKLIGHT (ret);
  else
    return NULL;
}


/* ------------------------------------------------------------------------ */

/**
 * DBusBacklightSkeleton:
 *
 * The #DBusBacklightSkeleton structure contains only private data and should only be accessed using the provided API.
 */

/**
 * DBusBacklightSkeletonClass:
 * @parent_class: The parent class.
 *
 * Class structure for #DBusBacklightSkeleton.
 */

struct _DBusBacklightSkeletonPrivate
{
  GValue *properties;
  GList *changed_properties;
  GSource *changed_properties_idle_source;
  GMainContext *context;
  GMutex lock;
};

static void
_dbus_backlight_skeleton_handle_method_call (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name,
  const gchar *method_name,
  GVariant *parameters,
  GDBusMethodInvocation *invocation,
  gpointer user_data)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (user_data);
  _ExtendedGDBusMethodInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  guint num_extra;
  gsize n;
  guint signal_id;
  GValue return_value = G_VALUE_INIT;
  info = (_ExtendedGDBusMethodInfo *) g_dbus_method_invocation_get_method_info (invocation);
  g_assert (info != NULL);
  num_params = g_variant_n_children (parameters);
  num_extra = info->pass_fdlist ? 3 : 2;  paramv = g_new0 (GValue, num_params + num_extra);
  n = 0;
  g_value_init (&paramv[n], DBUS_TYPE_BACKLIGHT);
  g_value_set_object (&paramv[n++], skeleton);
  g_value_init (&paramv[n], G_TYPE_DBUS_METHOD_INVOCATION);
  g_value_set_object (&paramv[n++], invocation);
  if (info->pass_fdlist)
    {
#ifdef G_OS_UNIX
      g_value_init (&paramv[n], G_TYPE_UNIX_FD_LIST);
      g_value_set_object (&paramv[n++], g_dbus_message_get_unix_fd_list (g_dbus_method_invocation_get_message (invocation)));
#else
      g_assert_not_reached ();
#endif
    }
  g_variant_iter_init (&iter, parameters);
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.in_args[n - num_extra];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, DBUS_TYPE_BACKLIGHT);
  g_value_init (&return_value, G_TYPE_BOOLEAN);
  g_signal_emitv (paramv, signal_id, 0, &return_value);
  if (!g_value_get_boolean (&return_value))
    g_dbus_method_invocation_return_error (invocation, G_DBUS_ERROR, G_DBUS_ERROR_UNKNOWN_METHOD, "Method %s is not implemented on interface %s", method_name, interface_name);
  g_value_unset (&return_value);
  for (n = 0; n < num_params + num_extra; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static GVariant *
_dbus_backlight_skeleton_handle_get_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GError **error,
  gpointer user_data)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  GVariant *ret;
  ret = NULL;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_backlight_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      g_value_init (&value, pspec->value_type);
      g_object_get_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      ret = g_dbus_gvalue_to_gvariant (&value, G_VARIANT_TYPE (info->parent_struct.signature));
      g_value_unset (&value);
    }
  return ret;
}

static gboolean
_dbus_backlight_skeleton_handle_set_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GVariant *variant,
  GError **error,
  gpointer user_data)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  gboolean ret;
  ret = FALSE;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_backlight_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      if (info->use_gvariant)
        g_value_set_variant (&value, variant);
      else
        g_dbus_gvariant_to_gvalue (variant, &value);
      g_object_set_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      g_value_unset (&value);
      ret = TRUE;
    }
  return ret;
}

static const GDBusInterfaceVTable _dbus_backlight_skeleton_vtable =
{
  _dbus_backlight_skeleton_handle_method_call,
  _dbus_backlight_skeleton_handle_get_property,
  _dbus_backlight_skeleton_handle_set_property,
  {NULL}
};

static GDBusInterfaceInfo *
dbus_backlight_skeleton_dbus_interface_get_info (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return dbus_backlight_interface_info ();
}

static GDBusInterfaceVTable *
dbus_backlight_skeleton_dbus_interface_get_vtable (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return (GDBusInterfaceVTable *) &_dbus_backlight_skeleton_vtable;
}

static GVariant *
dbus_backlight_skeleton_dbus_interface_get_properties (GDBusInterfaceSkeleton *_skeleton)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (_skeleton);

  GVariantBuilder builder;
  guint n;
  g_variant_builder_init (&builder, G_VARIANT_TYPE ("a{sv}"));
  if (_dbus_backlight_interface_info.parent_struct.properties == NULL)
    goto out;
  for (n = 0; _dbus_backlight_interface_info.parent_struct.properties[n] != NULL; n++)
    {
      GDBusPropertyInfo *info = _dbus_backlight_interface_info.parent_struct.properties[n];
      if (info->flags & G_DBUS_PROPERTY_INFO_FLAGS_READABLE)
        {
          GVariant *value;
          value = _dbus_backlight_skeleton_handle_get_property (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)), NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.Backlight", info->name, NULL, skeleton);
          if (value != NULL)
            {
              g_variant_take_ref (value);
              g_variant_builder_add (&builder, "{sv}", info->name, value);
              g_variant_unref (value);
            }
        }
    }
out:
  return g_variant_builder_end (&builder);
}

static gboolean _dbus_backlight_emit_changed (gpointer user_data);

static void
dbus_backlight_skeleton_dbus_interface_flush (GDBusInterfaceSkeleton *_skeleton)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (_skeleton);
  gboolean emit_changed = FALSE;

  g_mutex_lock (&skeleton->priv->lock);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    {
      g_source_destroy (skeleton->priv->changed_properties_idle_source);
      skeleton->priv->changed_properties_idle_source = NULL;
      emit_changed = TRUE;
    }
  g_mutex_unlock (&skeleton->priv->lock);

  if (emit_changed)
    _dbus_backlight_emit_changed (skeleton);
}

static void dbus_backlight_skeleton_iface_init (DBusBacklightIface *iface);
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (DBusBacklightSkeleton, dbus_backlight_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_ADD_PRIVATE (DBusBacklightSkeleton)
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_BACKLIGHT, dbus_backlight_skeleton_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (DBusBacklightSkeleton, dbus_backlight_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_BACKLIGHT, dbus_backlight_skeleton_iface_init))

#endif
static void
dbus_backlight_skeleton_finalize (GObject *object)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  guint n;
  for (n = 0; n < 7; n++)
    g_value_unset (&skeleton->priv->properties[n]);
  g_free (skeleton->priv->properties);
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    g_source_destroy (skeleton->priv->changed_properties_idle_source);
  g_main_context_unref (skeleton->priv->context);
  g_mutex_clear (&skeleton->priv->lock);
  G_OBJECT_CLASS (dbus_backlight_skeleton_parent_class)->finalize (object);
}

static void
dbus_backlight_skeleton_get_property (GObject      *object,
  guint         prop_id,
  GValue       *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  g_assert (prop_id != 0 && prop_id - 1 < 7);
  g_mutex_lock (&skeleton->priv->lock);
  g_value_copy (&skeleton->priv->properties[prop_id - 1], value);
  g_mutex_unlock (&skeleton->priv->lock);
}

static gboolean
_dbus_backlight_emit_changed (gpointer user_data)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (user_data);
  GList *l;
  GVariantBuilder builder;
  GVariantBuilder invalidated_builder;
  guint num_changes;

  g_mutex_lock (&skeleton->priv->lock);
  g_variant_builder_init (&builder, G_VARIANT_TYPE ("a{sv}"));
  g_variant_builder_init (&invalidated_builder, G_VARIANT_TYPE ("as"));
  for (l = skeleton->priv->changed_properties, num_changes = 0; l != NULL; l = l->next)
    {
      ChangedProperty *cp = l->data;
      GVariant *variant;
      const GValue *cur_value;

      cur_value = &skeleton->priv->properties[cp->prop_id - 1];
      if (!_g_value_equal (cur_value, &cp->orig_value))
        {
          variant = g_dbus_gvalue_to_gvariant (cur_value, G_VARIANT_TYPE (cp->info->parent_struct.signature));
          g_variant_builder_add (&builder, "{sv}", cp->info->parent_struct.name, variant);
          g_variant_unref (variant);
          num_changes++;
        }
    }
  if (num_changes > 0)
    {
      GList *connections, *ll;
      GVariant *signal_variant;
      signal_variant = g_variant_ref_sink (g_variant_new ("(sa{sv}as)", "org.sessiond.session1.Backlight",
                                           &builder, &invalidated_builder));
      connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));
      for (ll = connections; ll != NULL; ll = ll->next)
        {
          GDBusConnection *connection = ll->data;

          g_dbus_connection_emit_signal (connection,
                                         NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)),
                                         "org.freedesktop.DBus.Properties",
                                         "PropertiesChanged",
                                         signal_variant,
                                         NULL);
        }
      g_variant_unref (signal_variant);
      g_list_free_full (connections, g_object_unref);
    }
  else
    {
      g_variant_builder_clear (&builder);
      g_variant_builder_clear (&invalidated_builder);
    }
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  skeleton->priv->changed_properties = NULL;
  skeleton->priv->changed_properties_idle_source = NULL;
  g_mutex_unlock (&skeleton->priv->lock);
  return FALSE;
}

static void
_dbus_backlight_schedule_emit_changed (DBusBacklightSkeleton *skeleton, const _ExtendedGDBusPropertyInfo *info, guint prop_id, const GValue *orig_value)
{
  ChangedProperty *cp;
  GList *l;
  cp = NULL;
  for (l = skeleton->priv->changed_properties; l != NULL; l = l->next)
    {
      ChangedProperty *i_cp = l->data;
      if (i_cp->info == info)
        {
          cp = i_cp;
          break;
        }
    }
  if (cp == NULL)
    {
      cp = g_new0 (ChangedProperty, 1);
      cp->prop_id = prop_id;
      cp->info = info;
      skeleton->priv->changed_properties = g_list_prepend (skeleton->priv->changed_properties, cp);
      g_value_init (&cp->orig_value, G_VALUE_TYPE (orig_value));
      g_value_copy (orig_value, &cp->orig_value);
    }
}

static void
dbus_backlight_skeleton_notify (GObject      *object,
  GParamSpec *pspec G_GNUC_UNUSED)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  g_mutex_lock (&skeleton->priv->lock);
  if (skeleton->priv->changed_properties != NULL &&
      skeleton->priv->changed_properties_idle_source == NULL)
    {
      skeleton->priv->changed_properties_idle_source = g_idle_source_new ();
      g_source_set_priority (skeleton->priv->changed_properties_idle_source, G_PRIORITY_DEFAULT);
      g_source_set_callback (skeleton->priv->changed_properties_idle_source, _dbus_backlight_emit_changed, g_object_ref (skeleton), (GDestroyNotify) g_object_unref);
      g_source_set_name (skeleton->priv->changed_properties_idle_source, "[generated] _dbus_backlight_emit_changed");
      g_source_attach (skeleton->priv->changed_properties_idle_source, skeleton->priv->context);
      g_source_unref (skeleton->priv->changed_properties_idle_source);
    }
  g_mutex_unlock (&skeleton->priv->lock);
}

static void
dbus_backlight_skeleton_set_property (GObject      *object,
  guint         prop_id,
  const GValue *value,
  GParamSpec   *pspec)
{
  const _ExtendedGDBusPropertyInfo *info;
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  g_assert (prop_id != 0 && prop_id - 1 < 7);
  info = (const _ExtendedGDBusPropertyInfo *) _dbus_backlight_property_info_pointers[prop_id - 1];
  g_mutex_lock (&skeleton->priv->lock);
  g_object_freeze_notify (object);
  if (!_g_value_equal (value, &skeleton->priv->properties[prop_id - 1]))
    {
      if (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)) != NULL &&
          info->emits_changed_signal)
        _dbus_backlight_schedule_emit_changed (skeleton, info, prop_id, &skeleton->priv->properties[prop_id - 1]);
      g_value_copy (value, &skeleton->priv->properties[prop_id - 1]);
      g_object_notify_by_pspec (object, pspec);
    }
  g_mutex_unlock (&skeleton->priv->lock);
  g_object_thaw_notify (object);
}

static void
dbus_backlight_skeleton_init (DBusBacklightSkeleton *skeleton)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  skeleton->priv = dbus_backlight_skeleton_get_instance_private (skeleton);
#else
  skeleton->priv = G_TYPE_INSTANCE_GET_PRIVATE (skeleton, DBUS_TYPE_BACKLIGHT_SKELETON, DBusBacklightSkeletonPrivate);
#endif

  g_mutex_init (&skeleton->priv->lock);
  skeleton->priv->context = g_main_context_ref_thread_default ();
  skeleton->priv->properties = g_new0 (GValue, 7);
  g_value_init (&skeleton->priv->properties[0], G_TYPE_BOOLEAN);
  g_value_init (&skeleton->priv->properties[1], G_TYPE_STRING);
  g_value_init (&skeleton->priv->properties[2], G_TYPE_STRING);
  g_value_init (&skeleton->priv->properties[3], G_TYPE_STRING);
  g_value_init (&skeleton->priv->properties[4], G_TYPE_STRING);
  g_value_init (&skeleton->priv->properties[5], G_TYPE_UINT);
  g_value_init (&skeleton->priv->properties[6], G_TYPE_UINT);
}

static gboolean 
dbus_backlight_skeleton_get_online (DBusBacklight *object)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  gboolean value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_boolean (&(skeleton->priv->properties[0]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static const gchar *
dbus_backlight_skeleton_get_name (DBusBacklight *object)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  const gchar *value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_string (&(skeleton->priv->properties[1]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static const gchar *
dbus_backlight_skeleton_get_subsystem (DBusBacklight *object)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  const gchar *value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_string (&(skeleton->priv->properties[2]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static const gchar *
dbus_backlight_skeleton_get_sys_path (DBusBacklight *object)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  const gchar *value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_string (&(skeleton->priv->properties[3]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static const gchar *
dbus_backlight_skeleton_get_dev_path (DBusBacklight *object)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  const gchar *value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_string (&(skeleton->priv->properties[4]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static guint 
dbus_backlight_skeleton_get_max_brightness (DBusBacklight *object)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  guint value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_uint (&(skeleton->priv->properties[5]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static guint 
dbus_backlight_skeleton_get_brightness (DBusBacklight *object)
{
  DBusBacklightSkeleton *skeleton = DBUS_BACKLIGHT_SKELETON (object);
  guint value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_uint (&(skeleton->priv->properties[6]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static void
dbus_backlight_skeleton_class_init (DBusBacklightSkeletonClass *klass)
{
  GObjectClass *gobject_class;
  GDBusInterfaceSkeletonClass *skeleton_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize = dbus_backlight_skeleton_finalize;
  gobject_class->get_property = dbus_backlight_skeleton_get_property;
  gobject_class->set_property = dbus_backlight_skeleton_set_property;
  gobject_class->notify       = dbus_backlight_skeleton_notify;


  dbus_backlight_override_properties (gobject_class, 1);

  skeleton_class = G_DBUS_INTERFACE_SKELETON_CLASS (klass);
  skeleton_class->get_info = dbus_backlight_skeleton_dbus_interface_get_info;
  skeleton_class->get_properties = dbus_backlight_skeleton_dbus_interface_get_properties;
  skeleton_class->flush = dbus_backlight_skeleton_dbus_interface_flush;
  skeleton_class->get_vtable = dbus_backlight_skeleton_dbus_interface_get_vtable;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (DBusBacklightSkeletonPrivate));
#endif
}

static void
dbus_backlight_skeleton_iface_init (DBusBacklightIface *iface)
{
  iface->get_online = dbus_backlight_skeleton_get_online;
  iface->get_name = dbus_backlight_skeleton_get_name;
  iface->get_subsystem = dbus_backlight_skeleton_get_subsystem;
  iface->get_sys_path = dbus_backlight_skeleton_get_sys_path;
  iface->get_dev_path = dbus_backlight_skeleton_get_dev_path;
  iface->get_max_brightness = dbus_backlight_skeleton_get_max_brightness;
  iface->get_brightness = dbus_backlight_skeleton_get_brightness;
}

/**
 * dbus_backlight_skeleton_new:
 *
 * Creates a skeleton object for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-Backlight.top_of_page">org.sessiond.session1.Backlight</link>.
 *
 * Returns: (transfer full) (type DBusBacklightSkeleton): The skeleton object.
 */
DBusBacklight *
dbus_backlight_skeleton_new (void)
{
  return DBUS_BACKLIGHT (g_object_new (DBUS_TYPE_BACKLIGHT_SKELETON, NULL));
}

/* ------------------------------------------------------------------------
 * Code for interface org.sessiond.session1.AudioSink
 * ------------------------------------------------------------------------
 */

/**
 * SECTION:DBusAudioSink
 * @title: DBusAudioSink
 * @short_description: Generated C code for the org.sessiond.session1.AudioSink D-Bus interface
 *
 * This section contains code for working with the <link linkend="gdbus-interface-org-sessiond-session1-AudioSink.top_of_page">org.sessiond.session1.AudioSink</link> D-Bus interface in C.
 */

/* ---- Introspection data for org.sessiond.session1.AudioSink ---- */

static const _ExtendedGDBusArgInfo _dbus_audio_sink_method_info_set_volume_IN_ARG_volume =
{
  {
    -1,
    (gchar *) "volume",
    (gchar *) "d",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_audio_sink_method_info_set_volume_IN_ARG_pointers[] =
{
  &_dbus_audio_sink_method_info_set_volume_IN_ARG_volume.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_audio_sink_method_info_set_volume =
{
  {
    -1,
    (gchar *) "SetVolume",
    (GDBusArgInfo **) &_dbus_audio_sink_method_info_set_volume_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-set-volume",
  FALSE
};

static const _ExtendedGDBusArgInfo _dbus_audio_sink_method_info_inc_volume_IN_ARG_value =
{
  {
    -1,
    (gchar *) "value",
    (gchar *) "d",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_audio_sink_method_info_inc_volume_IN_ARG_pointers[] =
{
  &_dbus_audio_sink_method_info_inc_volume_IN_ARG_value.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _dbus_audio_sink_method_info_inc_volume_OUT_ARG_volume =
{
  {
    -1,
    (gchar *) "volume",
    (gchar *) "d",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_audio_sink_method_info_inc_volume_OUT_ARG_pointers[] =
{
  &_dbus_audio_sink_method_info_inc_volume_OUT_ARG_volume.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_audio_sink_method_info_inc_volume =
{
  {
    -1,
    (gchar *) "IncVolume",
    (GDBusArgInfo **) &_dbus_audio_sink_method_info_inc_volume_IN_ARG_pointers,
    (GDBusArgInfo **) &_dbus_audio_sink_method_info_inc_volume_OUT_ARG_pointers,
    NULL
  },
  "handle-inc-volume",
  FALSE
};

static const _ExtendedGDBusArgInfo _dbus_audio_sink_method_info_set_mute_IN_ARG_mute =
{
  {
    -1,
    (gchar *) "mute",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_audio_sink_method_info_set_mute_IN_ARG_pointers[] =
{
  &_dbus_audio_sink_method_info_set_mute_IN_ARG_mute.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_audio_sink_method_info_set_mute =
{
  {
    -1,
    (gchar *) "SetMute",
    (GDBusArgInfo **) &_dbus_audio_sink_method_info_set_mute_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-set-mute",
  FALSE
};

static const _ExtendedGDBusArgInfo _dbus_audio_sink_method_info_toggle_mute_OUT_ARG_mute =
{
  {
    -1,
    (gchar *) "mute",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_audio_sink_method_info_toggle_mute_OUT_ARG_pointers[] =
{
  &_dbus_audio_sink_method_info_toggle_mute_OUT_ARG_mute.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _dbus_audio_sink_method_info_toggle_mute =
{
  {
    -1,
    (gchar *) "ToggleMute",
    NULL,
    (GDBusArgInfo **) &_dbus_audio_sink_method_info_toggle_mute_OUT_ARG_pointers,
    NULL
  },
  "handle-toggle-mute",
  FALSE
};

static const GDBusMethodInfo * const _dbus_audio_sink_method_info_pointers[] =
{
  &_dbus_audio_sink_method_info_set_volume.parent_struct,
  &_dbus_audio_sink_method_info_inc_volume.parent_struct,
  &_dbus_audio_sink_method_info_set_mute.parent_struct,
  &_dbus_audio_sink_method_info_toggle_mute.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _dbus_audio_sink_signal_info_change_mute_ARG_mute =
{
  {
    -1,
    (gchar *) "mute",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_audio_sink_signal_info_change_mute_ARG_pointers[] =
{
  &_dbus_audio_sink_signal_info_change_mute_ARG_mute.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_audio_sink_signal_info_change_mute =
{
  {
    -1,
    (gchar *) "ChangeMute",
    (GDBusArgInfo **) &_dbus_audio_sink_signal_info_change_mute_ARG_pointers,
    NULL
  },
  "change-mute"
};

static const _ExtendedGDBusArgInfo _dbus_audio_sink_signal_info_change_volume_ARG_volume =
{
  {
    -1,
    (gchar *) "volume",
    (gchar *) "d",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _dbus_audio_sink_signal_info_change_volume_ARG_pointers[] =
{
  &_dbus_audio_sink_signal_info_change_volume_ARG_volume.parent_struct,
  NULL
};

static const _ExtendedGDBusSignalInfo _dbus_audio_sink_signal_info_change_volume =
{
  {
    -1,
    (gchar *) "ChangeVolume",
    (GDBusArgInfo **) &_dbus_audio_sink_signal_info_change_volume_ARG_pointers,
    NULL
  },
  "change-volume"
};

static const GDBusSignalInfo * const _dbus_audio_sink_signal_info_pointers[] =
{
  &_dbus_audio_sink_signal_info_change_mute.parent_struct,
  &_dbus_audio_sink_signal_info_change_volume.parent_struct,
  NULL
};

static const _ExtendedGDBusPropertyInfo _dbus_audio_sink_property_info_id =
{
  {
    -1,
    (gchar *) "Id",
    (gchar *) "u",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "id",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_audio_sink_property_info_name =
{
  {
    -1,
    (gchar *) "Name",
    (gchar *) "s",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "name",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_audio_sink_property_info_mute =
{
  {
    -1,
    (gchar *) "Mute",
    (gchar *) "b",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "mute",
  FALSE,
  TRUE
};

static const _ExtendedGDBusPropertyInfo _dbus_audio_sink_property_info_volume =
{
  {
    -1,
    (gchar *) "Volume",
    (gchar *) "d",
    G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
    NULL
  },
  "volume",
  FALSE,
  TRUE
};

static const GDBusPropertyInfo * const _dbus_audio_sink_property_info_pointers[] =
{
  &_dbus_audio_sink_property_info_id.parent_struct,
  &_dbus_audio_sink_property_info_name.parent_struct,
  &_dbus_audio_sink_property_info_mute.parent_struct,
  &_dbus_audio_sink_property_info_volume.parent_struct,
  NULL
};

static const _ExtendedGDBusInterfaceInfo _dbus_audio_sink_interface_info =
{
  {
    -1,
    (gchar *) "org.sessiond.session1.AudioSink",
    (GDBusMethodInfo **) &_dbus_audio_sink_method_info_pointers,
    (GDBusSignalInfo **) &_dbus_audio_sink_signal_info_pointers,
    (GDBusPropertyInfo **) &_dbus_audio_sink_property_info_pointers,
    NULL
  },
  "audio-sink",
};


/**
 * dbus_audio_sink_interface_info:
 *
 * Gets a machine-readable description of the <link linkend="gdbus-interface-org-sessiond-session1-AudioSink.top_of_page">org.sessiond.session1.AudioSink</link> D-Bus interface.
 *
 * Returns: (transfer none): A #GDBusInterfaceInfo. Do not free.
 */
GDBusInterfaceInfo *
dbus_audio_sink_interface_info (void)
{
  return (GDBusInterfaceInfo *) &_dbus_audio_sink_interface_info.parent_struct;
}

/**
 * dbus_audio_sink_override_properties:
 * @klass: The class structure for a #GObject derived class.
 * @property_id_begin: The property id to assign to the first overridden property.
 *
 * Overrides all #GObject properties in the #DBusAudioSink interface for a concrete class.
 * The properties are overridden in the order they are defined.
 *
 * Returns: The last property id.
 */
guint
dbus_audio_sink_override_properties (GObjectClass *klass, guint property_id_begin)
{
  g_object_class_override_property (klass, property_id_begin++, "id");
  g_object_class_override_property (klass, property_id_begin++, "name");
  g_object_class_override_property (klass, property_id_begin++, "mute");
  g_object_class_override_property (klass, property_id_begin++, "volume");
  return property_id_begin - 1;
}



/**
 * DBusAudioSink:
 *
 * Abstract interface type for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-AudioSink.top_of_page">org.sessiond.session1.AudioSink</link>.
 */

/**
 * DBusAudioSinkIface:
 * @parent_iface: The parent interface.
 * @handle_inc_volume: Handler for the #DBusAudioSink::handle-inc-volume signal.
 * @handle_set_mute: Handler for the #DBusAudioSink::handle-set-mute signal.
 * @handle_set_volume: Handler for the #DBusAudioSink::handle-set-volume signal.
 * @handle_toggle_mute: Handler for the #DBusAudioSink::handle-toggle-mute signal.
 * @get_id: Getter for the #DBusAudioSink:id property.
 * @get_mute: Getter for the #DBusAudioSink:mute property.
 * @get_name: Getter for the #DBusAudioSink:name property.
 * @get_volume: Getter for the #DBusAudioSink:volume property.
 * @change_mute: Handler for the #DBusAudioSink::change-mute signal.
 * @change_volume: Handler for the #DBusAudioSink::change-volume signal.
 *
 * Virtual table for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-AudioSink.top_of_page">org.sessiond.session1.AudioSink</link>.
 */

typedef DBusAudioSinkIface DBusAudioSinkInterface;
G_DEFINE_INTERFACE (DBusAudioSink, dbus_audio_sink, G_TYPE_OBJECT)

static void
dbus_audio_sink_default_init (DBusAudioSinkIface *iface)
{
  /* GObject signals for incoming D-Bus method calls: */
  /**
   * DBusAudioSink::handle-set-volume:
   * @object: A #DBusAudioSink.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_volume: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.SetVolume">SetVolume()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_audio_sink_complete_set_volume() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-set-volume",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusAudioSinkIface, handle_set_volume),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_DOUBLE);

  /**
   * DBusAudioSink::handle-inc-volume:
   * @object: A #DBusAudioSink.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_value: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.IncVolume">IncVolume()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_audio_sink_complete_inc_volume() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-inc-volume",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusAudioSinkIface, handle_inc_volume),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_DOUBLE);

  /**
   * DBusAudioSink::handle-set-mute:
   * @object: A #DBusAudioSink.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_mute: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.SetMute">SetMute()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_audio_sink_complete_set_mute() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-set-mute",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusAudioSinkIface, handle_set_mute),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_BOOLEAN);

  /**
   * DBusAudioSink::handle-toggle-mute:
   * @object: A #DBusAudioSink.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.ToggleMute">ToggleMute()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call dbus_audio_sink_complete_toggle_mute() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-toggle-mute",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusAudioSinkIface, handle_toggle_mute),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /* GObject signals for received D-Bus signals: */
  /**
   * DBusAudioSink::change-mute:
   * @object: A #DBusAudioSink.
   * @arg_mute: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-AudioSink.ChangeMute">"ChangeMute"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("change-mute",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusAudioSinkIface, change_mute),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_BOOLEAN);

  /**
   * DBusAudioSink::change-volume:
   * @object: A #DBusAudioSink.
   * @arg_volume: Argument.
   *
   * On the client-side, this signal is emitted whenever the D-Bus signal <link linkend="gdbus-signal-org-sessiond-session1-AudioSink.ChangeVolume">"ChangeVolume"</link> is received.
   *
   * On the service-side, this signal can be used with e.g. g_signal_emit_by_name() to make the object emit the D-Bus signal.
   */
  g_signal_new ("change-volume",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (DBusAudioSinkIface, change_volume),
    NULL,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_NONE,
    1, G_TYPE_DOUBLE);

  /* GObject properties for D-Bus properties: */
  /**
   * DBusAudioSink:id:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Id">"Id"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_uint ("id", "Id", "Id", 0, G_MAXUINT32, 0, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusAudioSink:name:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Name">"Name"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_string ("name", "Name", "Name", NULL, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusAudioSink:mute:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Mute">"Mute"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_boolean ("mute", "Mute", "Mute", FALSE, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
  /**
   * DBusAudioSink:volume:
   *
   * Represents the D-Bus property <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Volume">"Volume"</link>.
   *
   * Since the D-Bus property for this #GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.
   */
  g_object_interface_install_property (iface,
    g_param_spec_double ("volume", "Volume", "Volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS));
}

/**
 * dbus_audio_sink_get_id: (skip)
 * @object: A #DBusAudioSink.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Id">"Id"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
guint 
dbus_audio_sink_get_id (DBusAudioSink *object)
{
  return DBUS_AUDIO_SINK_GET_IFACE (object)->get_id (object);
}

/**
 * dbus_audio_sink_set_id: (skip)
 * @object: A #DBusAudioSink.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Id">"Id"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_audio_sink_set_id (DBusAudioSink *object, guint value)
{
  g_object_set (G_OBJECT (object), "id", value, NULL);
}

/**
 * dbus_audio_sink_get_name: (skip)
 * @object: A #DBusAudioSink.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Name">"Name"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where @object was constructed. Use dbus_audio_sink_dup_name() if on another thread.
 *
 * Returns: (transfer none) (nullable): The property value or %NULL if the property is not set. Do not free the returned value, it belongs to @object.
 */
const gchar *
dbus_audio_sink_get_name (DBusAudioSink *object)
{
  return DBUS_AUDIO_SINK_GET_IFACE (object)->get_name (object);
}

/**
 * dbus_audio_sink_dup_name: (skip)
 * @object: A #DBusAudioSink.
 *
 * Gets a copy of the <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Name">"Name"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: (transfer full) (nullable): The property value or %NULL if the property is not set. The returned value should be freed with g_free().
 */
gchar *
dbus_audio_sink_dup_name (DBusAudioSink *object)
{
  gchar *value;
  g_object_get (G_OBJECT (object), "name", &value, NULL);
  return value;
}

/**
 * dbus_audio_sink_set_name: (skip)
 * @object: A #DBusAudioSink.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Name">"Name"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_audio_sink_set_name (DBusAudioSink *object, const gchar *value)
{
  g_object_set (G_OBJECT (object), "name", value, NULL);
}

/**
 * dbus_audio_sink_get_mute: (skip)
 * @object: A #DBusAudioSink.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Mute">"Mute"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
gboolean 
dbus_audio_sink_get_mute (DBusAudioSink *object)
{
  return DBUS_AUDIO_SINK_GET_IFACE (object)->get_mute (object);
}

/**
 * dbus_audio_sink_set_mute: (skip)
 * @object: A #DBusAudioSink.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Mute">"Mute"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_audio_sink_set_mute (DBusAudioSink *object, gboolean value)
{
  g_object_set (G_OBJECT (object), "mute", value, NULL);
}

/**
 * dbus_audio_sink_get_volume: (skip)
 * @object: A #DBusAudioSink.
 *
 * Gets the value of the <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Volume">"Volume"</link> D-Bus property.
 *
 * Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.
 *
 * Returns: The property value.
 */
gdouble 
dbus_audio_sink_get_volume (DBusAudioSink *object)
{
  return DBUS_AUDIO_SINK_GET_IFACE (object)->get_volume (object);
}

/**
 * dbus_audio_sink_set_volume: (skip)
 * @object: A #DBusAudioSink.
 * @value: The value to set.
 *
 * Sets the <link linkend="gdbus-property-org-sessiond-session1-AudioSink.Volume">"Volume"</link> D-Bus property to @value.
 *
 * Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.
 */
void
dbus_audio_sink_set_volume (DBusAudioSink *object, gdouble value)
{
  g_object_set (G_OBJECT (object), "volume", value, NULL);
}

/**
 * dbus_audio_sink_emit_change_mute:
 * @object: A #DBusAudioSink.
 * @arg_mute: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-AudioSink.ChangeMute">"ChangeMute"</link> D-Bus signal.
 */
void
dbus_audio_sink_emit_change_mute (
    DBusAudioSink *object,
    gboolean arg_mute)
{
  g_signal_emit_by_name (object, "change-mute", arg_mute);
}

/**
 * dbus_audio_sink_emit_change_volume:
 * @object: A #DBusAudioSink.
 * @arg_volume: Argument to pass with the signal.
 *
 * Emits the <link linkend="gdbus-signal-org-sessiond-session1-AudioSink.ChangeVolume">"ChangeVolume"</link> D-Bus signal.
 */
void
dbus_audio_sink_emit_change_volume (
    DBusAudioSink *object,
    gdouble arg_volume)
{
  g_signal_emit_by_name (object, "change-volume", arg_volume);
}

/**
 * dbus_audio_sink_call_set_volume:
 * @proxy: A #DBusAudioSinkProxy.
 * @arg_volume: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.SetVolume">SetVolume()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_audio_sink_call_set_volume_finish() to get the result of the operation.
 *
 * See dbus_audio_sink_call_set_volume_sync() for the synchronous, blocking version of this method.
 */
void
dbus_audio_sink_call_set_volume (
    DBusAudioSink *proxy,
    gdouble arg_volume,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "SetVolume",
    g_variant_new ("(d)",
                   arg_volume),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_audio_sink_call_set_volume_finish:
 * @proxy: A #DBusAudioSinkProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_audio_sink_call_set_volume().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_audio_sink_call_set_volume().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_audio_sink_call_set_volume_finish (
    DBusAudioSink *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_audio_sink_call_set_volume_sync:
 * @proxy: A #DBusAudioSinkProxy.
 * @arg_volume: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.SetVolume">SetVolume()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_audio_sink_call_set_volume() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_audio_sink_call_set_volume_sync (
    DBusAudioSink *proxy,
    gdouble arg_volume,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "SetVolume",
    g_variant_new ("(d)",
                   arg_volume),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_audio_sink_call_inc_volume:
 * @proxy: A #DBusAudioSinkProxy.
 * @arg_value: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.IncVolume">IncVolume()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_audio_sink_call_inc_volume_finish() to get the result of the operation.
 *
 * See dbus_audio_sink_call_inc_volume_sync() for the synchronous, blocking version of this method.
 */
void
dbus_audio_sink_call_inc_volume (
    DBusAudioSink *proxy,
    gdouble arg_value,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "IncVolume",
    g_variant_new ("(d)",
                   arg_value),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_audio_sink_call_inc_volume_finish:
 * @proxy: A #DBusAudioSinkProxy.
 * @out_volume: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_audio_sink_call_inc_volume().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_audio_sink_call_inc_volume().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_audio_sink_call_inc_volume_finish (
    DBusAudioSink *proxy,
    gdouble *out_volume,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(d)",
                 out_volume);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_audio_sink_call_inc_volume_sync:
 * @proxy: A #DBusAudioSinkProxy.
 * @arg_value: Argument to pass with the method invocation.
 * @out_volume: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.IncVolume">IncVolume()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_audio_sink_call_inc_volume() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_audio_sink_call_inc_volume_sync (
    DBusAudioSink *proxy,
    gdouble arg_value,
    gdouble *out_volume,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "IncVolume",
    g_variant_new ("(d)",
                   arg_value),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(d)",
                 out_volume);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_audio_sink_call_set_mute:
 * @proxy: A #DBusAudioSinkProxy.
 * @arg_mute: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.SetMute">SetMute()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_audio_sink_call_set_mute_finish() to get the result of the operation.
 *
 * See dbus_audio_sink_call_set_mute_sync() for the synchronous, blocking version of this method.
 */
void
dbus_audio_sink_call_set_mute (
    DBusAudioSink *proxy,
    gboolean arg_mute,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "SetMute",
    g_variant_new ("(b)",
                   arg_mute),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_audio_sink_call_set_mute_finish:
 * @proxy: A #DBusAudioSinkProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_audio_sink_call_set_mute().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_audio_sink_call_set_mute().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_audio_sink_call_set_mute_finish (
    DBusAudioSink *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_audio_sink_call_set_mute_sync:
 * @proxy: A #DBusAudioSinkProxy.
 * @arg_mute: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.SetMute">SetMute()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_audio_sink_call_set_mute() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_audio_sink_call_set_mute_sync (
    DBusAudioSink *proxy,
    gboolean arg_mute,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "SetMute",
    g_variant_new ("(b)",
                   arg_mute),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_audio_sink_call_toggle_mute:
 * @proxy: A #DBusAudioSinkProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.ToggleMute">ToggleMute()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_audio_sink_call_toggle_mute_finish() to get the result of the operation.
 *
 * See dbus_audio_sink_call_toggle_mute_sync() for the synchronous, blocking version of this method.
 */
void
dbus_audio_sink_call_toggle_mute (
    DBusAudioSink *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "ToggleMute",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * dbus_audio_sink_call_toggle_mute_finish:
 * @proxy: A #DBusAudioSinkProxy.
 * @out_mute: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_audio_sink_call_toggle_mute().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with dbus_audio_sink_call_toggle_mute().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_audio_sink_call_toggle_mute_finish (
    DBusAudioSink *proxy,
    gboolean *out_mute,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(b)",
                 out_mute);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_audio_sink_call_toggle_mute_sync:
 * @proxy: A #DBusAudioSinkProxy.
 * @out_mute: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.ToggleMute">ToggleMute()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See dbus_audio_sink_call_toggle_mute() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
dbus_audio_sink_call_toggle_mute_sync (
    DBusAudioSink *proxy,
    gboolean *out_mute,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "ToggleMute",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(b)",
                 out_mute);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * dbus_audio_sink_complete_set_volume:
 * @object: A #DBusAudioSink.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.SetVolume">SetVolume()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_audio_sink_complete_set_volume (
    DBusAudioSink *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * dbus_audio_sink_complete_inc_volume:
 * @object: A #DBusAudioSink.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @volume: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.IncVolume">IncVolume()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_audio_sink_complete_inc_volume (
    DBusAudioSink *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    gdouble volume)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(d)",
                   volume));
}

/**
 * dbus_audio_sink_complete_set_mute:
 * @object: A #DBusAudioSink.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.SetMute">SetMute()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_audio_sink_complete_set_mute (
    DBusAudioSink *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * dbus_audio_sink_complete_toggle_mute:
 * @object: A #DBusAudioSink.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @mute: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-sessiond-session1-AudioSink.ToggleMute">ToggleMute()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
dbus_audio_sink_complete_toggle_mute (
    DBusAudioSink *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    gboolean mute)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(b)",
                   mute));
}

/* ------------------------------------------------------------------------ */

/**
 * DBusAudioSinkProxy:
 *
 * The #DBusAudioSinkProxy structure contains only private data and should only be accessed using the provided API.
 */

/**
 * DBusAudioSinkProxyClass:
 * @parent_class: The parent class.
 *
 * Class structure for #DBusAudioSinkProxy.
 */

struct _DBusAudioSinkProxyPrivate
{
  GData *qdata;
};

static void dbus_audio_sink_proxy_iface_init (DBusAudioSinkIface *iface);

#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (DBusAudioSinkProxy, dbus_audio_sink_proxy, G_TYPE_DBUS_PROXY,
                         G_ADD_PRIVATE (DBusAudioSinkProxy)
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_AUDIO_SINK, dbus_audio_sink_proxy_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (DBusAudioSinkProxy, dbus_audio_sink_proxy, G_TYPE_DBUS_PROXY,
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_AUDIO_SINK, dbus_audio_sink_proxy_iface_init))

#endif
static void
dbus_audio_sink_proxy_finalize (GObject *object)
{
  DBusAudioSinkProxy *proxy = DBUS_AUDIO_SINK_PROXY (object);
  g_datalist_clear (&proxy->priv->qdata);
  G_OBJECT_CLASS (dbus_audio_sink_proxy_parent_class)->finalize (object);
}

static void
dbus_audio_sink_proxy_get_property (GObject      *object,
  guint         prop_id,
  GValue       *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
  const _ExtendedGDBusPropertyInfo *info;
  GVariant *variant;
  g_assert (prop_id != 0 && prop_id - 1 < 4);
  info = (const _ExtendedGDBusPropertyInfo *) _dbus_audio_sink_property_info_pointers[prop_id - 1];
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (object), info->parent_struct.name);
  if (info->use_gvariant)
    {
      g_value_set_variant (value, variant);
    }
  else
    {
      if (variant != NULL)
        g_dbus_gvariant_to_gvalue (variant, value);
    }
  if (variant != NULL)
    g_variant_unref (variant);
}

static void
dbus_audio_sink_proxy_set_property_cb (GDBusProxy *proxy,
  GAsyncResult *res,
  gpointer      user_data)
{
  const _ExtendedGDBusPropertyInfo *info = user_data;
  GError *error;
  GVariant *_ret;
  error = NULL;
  _ret = g_dbus_proxy_call_finish (proxy, res, &error);
  if (!_ret)
    {
      g_warning ("Error setting property '%s' on interface org.sessiond.session1.AudioSink: %s (%s, %d)",
                 info->parent_struct.name, 
                 error->message, g_quark_to_string (error->domain), error->code);
      g_error_free (error);
    }
  else
    {
      g_variant_unref (_ret);
    }
}

static void
dbus_audio_sink_proxy_set_property (GObject      *object,
  guint         prop_id,
  const GValue *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
  const _ExtendedGDBusPropertyInfo *info;
  GVariant *variant;
  g_assert (prop_id != 0 && prop_id - 1 < 4);
  info = (const _ExtendedGDBusPropertyInfo *) _dbus_audio_sink_property_info_pointers[prop_id - 1];
  variant = g_dbus_gvalue_to_gvariant (value, G_VARIANT_TYPE (info->parent_struct.signature));
  g_dbus_proxy_call (G_DBUS_PROXY (object),
    "org.freedesktop.DBus.Properties.Set",
    g_variant_new ("(ssv)", "org.sessiond.session1.AudioSink", info->parent_struct.name, variant),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    NULL, (GAsyncReadyCallback) dbus_audio_sink_proxy_set_property_cb, (GDBusPropertyInfo *) &info->parent_struct);
  g_variant_unref (variant);
}

static void
dbus_audio_sink_proxy_g_signal (GDBusProxy *proxy,
  const gchar *sender_name G_GNUC_UNUSED,
  const gchar *signal_name,
  GVariant *parameters)
{
  _ExtendedGDBusSignalInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  gsize n;
  guint signal_id;
  info = (_ExtendedGDBusSignalInfo *) g_dbus_interface_info_lookup_signal ((GDBusInterfaceInfo *) &_dbus_audio_sink_interface_info.parent_struct, signal_name);
  if (info == NULL)
    return;
  num_params = g_variant_n_children (parameters);
  paramv = g_new0 (GValue, num_params + 1);
  g_value_init (&paramv[0], DBUS_TYPE_AUDIO_SINK);
  g_value_set_object (&paramv[0], proxy);
  g_variant_iter_init (&iter, parameters);
  n = 1;
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.args[n - 1];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, DBUS_TYPE_AUDIO_SINK);
  g_signal_emitv (paramv, signal_id, 0, NULL);
  for (n = 0; n < num_params + 1; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static void
dbus_audio_sink_proxy_g_properties_changed (GDBusProxy *_proxy,
  GVariant *changed_properties,
  const gchar *const *invalidated_properties)
{
  DBusAudioSinkProxy *proxy = DBUS_AUDIO_SINK_PROXY (_proxy);
  guint n;
  const gchar *key;
  GVariantIter *iter;
  _ExtendedGDBusPropertyInfo *info;
  g_variant_get (changed_properties, "a{sv}", &iter);
  while (g_variant_iter_next (iter, "{&sv}", &key, NULL))
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_audio_sink_interface_info.parent_struct, key);
      g_datalist_remove_data (&proxy->priv->qdata, key);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
  g_variant_iter_free (iter);
  for (n = 0; invalidated_properties[n] != NULL; n++)
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_audio_sink_interface_info.parent_struct, invalidated_properties[n]);
      g_datalist_remove_data (&proxy->priv->qdata, invalidated_properties[n]);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
}

static guint 
dbus_audio_sink_proxy_get_id (DBusAudioSink *object)
{
  DBusAudioSinkProxy *proxy = DBUS_AUDIO_SINK_PROXY (object);
  GVariant *variant;
  guint value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Id");
  if (variant != NULL)
    {
      value = g_variant_get_uint32 (variant);
      g_variant_unref (variant);
    }
  return value;
}

static const gchar *
dbus_audio_sink_proxy_get_name (DBusAudioSink *object)
{
  DBusAudioSinkProxy *proxy = DBUS_AUDIO_SINK_PROXY (object);
  GVariant *variant;
  const gchar *value = NULL;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Name");
  if (variant != NULL)
    {
      value = g_variant_get_string (variant, NULL);
      g_variant_unref (variant);
    }
  return value;
}

static gboolean 
dbus_audio_sink_proxy_get_mute (DBusAudioSink *object)
{
  DBusAudioSinkProxy *proxy = DBUS_AUDIO_SINK_PROXY (object);
  GVariant *variant;
  gboolean value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Mute");
  if (variant != NULL)
    {
      value = g_variant_get_boolean (variant);
      g_variant_unref (variant);
    }
  return value;
}

static gdouble 
dbus_audio_sink_proxy_get_volume (DBusAudioSink *object)
{
  DBusAudioSinkProxy *proxy = DBUS_AUDIO_SINK_PROXY (object);
  GVariant *variant;
  gdouble value = 0;
  variant = g_dbus_proxy_get_cached_property (G_DBUS_PROXY (proxy), "Volume");
  if (variant != NULL)
    {
      value = g_variant_get_double (variant);
      g_variant_unref (variant);
    }
  return value;
}

static void
dbus_audio_sink_proxy_init (DBusAudioSinkProxy *proxy)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  proxy->priv = dbus_audio_sink_proxy_get_instance_private (proxy);
#else
  proxy->priv = G_TYPE_INSTANCE_GET_PRIVATE (proxy, DBUS_TYPE_AUDIO_SINK_PROXY, DBusAudioSinkProxyPrivate);
#endif

  g_dbus_proxy_set_interface_info (G_DBUS_PROXY (proxy), dbus_audio_sink_interface_info ());
}

static void
dbus_audio_sink_proxy_class_init (DBusAudioSinkProxyClass *klass)
{
  GObjectClass *gobject_class;
  GDBusProxyClass *proxy_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize     = dbus_audio_sink_proxy_finalize;
  gobject_class->get_property = dbus_audio_sink_proxy_get_property;
  gobject_class->set_property = dbus_audio_sink_proxy_set_property;

  proxy_class = G_DBUS_PROXY_CLASS (klass);
  proxy_class->g_signal = dbus_audio_sink_proxy_g_signal;
  proxy_class->g_properties_changed = dbus_audio_sink_proxy_g_properties_changed;

  dbus_audio_sink_override_properties (gobject_class, 1);

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (DBusAudioSinkProxyPrivate));
#endif
}

static void
dbus_audio_sink_proxy_iface_init (DBusAudioSinkIface *iface)
{
  iface->get_id = dbus_audio_sink_proxy_get_id;
  iface->get_name = dbus_audio_sink_proxy_get_name;
  iface->get_mute = dbus_audio_sink_proxy_get_mute;
  iface->get_volume = dbus_audio_sink_proxy_get_volume;
}

/**
 * dbus_audio_sink_proxy_new:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-AudioSink.top_of_page">org.sessiond.session1.AudioSink</link>. See g_dbus_proxy_new() for more details.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_audio_sink_proxy_new_finish() to get the result of the operation.
 *
 * See dbus_audio_sink_proxy_new_sync() for the synchronous, blocking version of this constructor.
 */
void
dbus_audio_sink_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (DBUS_TYPE_AUDIO_SINK_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.AudioSink", NULL);
}

/**
 * dbus_audio_sink_proxy_new_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_audio_sink_proxy_new().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with dbus_audio_sink_proxy_new().
 *
 * Returns: (transfer full) (type DBusAudioSinkProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusAudioSink *
dbus_audio_sink_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return DBUS_AUDIO_SINK (ret);
  else
    return NULL;
}

/**
 * dbus_audio_sink_proxy_new_sync:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Synchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-AudioSink.top_of_page">org.sessiond.session1.AudioSink</link>. See g_dbus_proxy_new_sync() for more details.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See dbus_audio_sink_proxy_new() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type DBusAudioSinkProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusAudioSink *
dbus_audio_sink_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (DBUS_TYPE_AUDIO_SINK_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.AudioSink", NULL);
  if (ret != NULL)
    return DBUS_AUDIO_SINK (ret);
  else
    return NULL;
}


/**
 * dbus_audio_sink_proxy_new_for_bus:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Like dbus_audio_sink_proxy_new() but takes a #GBusType instead of a #GDBusConnection.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call dbus_audio_sink_proxy_new_for_bus_finish() to get the result of the operation.
 *
 * See dbus_audio_sink_proxy_new_for_bus_sync() for the synchronous, blocking version of this constructor.
 */
void
dbus_audio_sink_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (DBUS_TYPE_AUDIO_SINK_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.AudioSink", NULL);
}

/**
 * dbus_audio_sink_proxy_new_for_bus_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to dbus_audio_sink_proxy_new_for_bus().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with dbus_audio_sink_proxy_new_for_bus().
 *
 * Returns: (transfer full) (type DBusAudioSinkProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusAudioSink *
dbus_audio_sink_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return DBUS_AUDIO_SINK (ret);
  else
    return NULL;
}

/**
 * dbus_audio_sink_proxy_new_for_bus_sync:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Like dbus_audio_sink_proxy_new_sync() but takes a #GBusType instead of a #GDBusConnection.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See dbus_audio_sink_proxy_new_for_bus() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type DBusAudioSinkProxy): The constructed proxy object or %NULL if @error is set.
 */
DBusAudioSink *
dbus_audio_sink_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (DBUS_TYPE_AUDIO_SINK_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.sessiond.session1.AudioSink", NULL);
  if (ret != NULL)
    return DBUS_AUDIO_SINK (ret);
  else
    return NULL;
}


/* ------------------------------------------------------------------------ */

/**
 * DBusAudioSinkSkeleton:
 *
 * The #DBusAudioSinkSkeleton structure contains only private data and should only be accessed using the provided API.
 */

/**
 * DBusAudioSinkSkeletonClass:
 * @parent_class: The parent class.
 *
 * Class structure for #DBusAudioSinkSkeleton.
 */

struct _DBusAudioSinkSkeletonPrivate
{
  GValue *properties;
  GList *changed_properties;
  GSource *changed_properties_idle_source;
  GMainContext *context;
  GMutex lock;
};

static void
_dbus_audio_sink_skeleton_handle_method_call (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name,
  const gchar *method_name,
  GVariant *parameters,
  GDBusMethodInvocation *invocation,
  gpointer user_data)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (user_data);
  _ExtendedGDBusMethodInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  guint num_extra;
  gsize n;
  guint signal_id;
  GValue return_value = G_VALUE_INIT;
  info = (_ExtendedGDBusMethodInfo *) g_dbus_method_invocation_get_method_info (invocation);
  g_assert (info != NULL);
  num_params = g_variant_n_children (parameters);
  num_extra = info->pass_fdlist ? 3 : 2;  paramv = g_new0 (GValue, num_params + num_extra);
  n = 0;
  g_value_init (&paramv[n], DBUS_TYPE_AUDIO_SINK);
  g_value_set_object (&paramv[n++], skeleton);
  g_value_init (&paramv[n], G_TYPE_DBUS_METHOD_INVOCATION);
  g_value_set_object (&paramv[n++], invocation);
  if (info->pass_fdlist)
    {
#ifdef G_OS_UNIX
      g_value_init (&paramv[n], G_TYPE_UNIX_FD_LIST);
      g_value_set_object (&paramv[n++], g_dbus_message_get_unix_fd_list (g_dbus_method_invocation_get_message (invocation)));
#else
      g_assert_not_reached ();
#endif
    }
  g_variant_iter_init (&iter, parameters);
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.in_args[n - num_extra];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, DBUS_TYPE_AUDIO_SINK);
  g_value_init (&return_value, G_TYPE_BOOLEAN);
  g_signal_emitv (paramv, signal_id, 0, &return_value);
  if (!g_value_get_boolean (&return_value))
    g_dbus_method_invocation_return_error (invocation, G_DBUS_ERROR, G_DBUS_ERROR_UNKNOWN_METHOD, "Method %s is not implemented on interface %s", method_name, interface_name);
  g_value_unset (&return_value);
  for (n = 0; n < num_params + num_extra; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static GVariant *
_dbus_audio_sink_skeleton_handle_get_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GError **error,
  gpointer user_data)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  GVariant *ret;
  ret = NULL;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_audio_sink_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      g_value_init (&value, pspec->value_type);
      g_object_get_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      ret = g_dbus_gvalue_to_gvariant (&value, G_VARIANT_TYPE (info->parent_struct.signature));
      g_value_unset (&value);
    }
  return ret;
}

static gboolean
_dbus_audio_sink_skeleton_handle_set_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GVariant *variant,
  GError **error,
  gpointer user_data)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  gboolean ret;
  ret = FALSE;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_dbus_audio_sink_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      if (info->use_gvariant)
        g_value_set_variant (&value, variant);
      else
        g_dbus_gvariant_to_gvalue (variant, &value);
      g_object_set_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      g_value_unset (&value);
      ret = TRUE;
    }
  return ret;
}

static const GDBusInterfaceVTable _dbus_audio_sink_skeleton_vtable =
{
  _dbus_audio_sink_skeleton_handle_method_call,
  _dbus_audio_sink_skeleton_handle_get_property,
  _dbus_audio_sink_skeleton_handle_set_property,
  {NULL}
};

static GDBusInterfaceInfo *
dbus_audio_sink_skeleton_dbus_interface_get_info (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return dbus_audio_sink_interface_info ();
}

static GDBusInterfaceVTable *
dbus_audio_sink_skeleton_dbus_interface_get_vtable (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return (GDBusInterfaceVTable *) &_dbus_audio_sink_skeleton_vtable;
}

static GVariant *
dbus_audio_sink_skeleton_dbus_interface_get_properties (GDBusInterfaceSkeleton *_skeleton)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (_skeleton);

  GVariantBuilder builder;
  guint n;
  g_variant_builder_init (&builder, G_VARIANT_TYPE ("a{sv}"));
  if (_dbus_audio_sink_interface_info.parent_struct.properties == NULL)
    goto out;
  for (n = 0; _dbus_audio_sink_interface_info.parent_struct.properties[n] != NULL; n++)
    {
      GDBusPropertyInfo *info = _dbus_audio_sink_interface_info.parent_struct.properties[n];
      if (info->flags & G_DBUS_PROPERTY_INFO_FLAGS_READABLE)
        {
          GVariant *value;
          value = _dbus_audio_sink_skeleton_handle_get_property (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)), NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.AudioSink", info->name, NULL, skeleton);
          if (value != NULL)
            {
              g_variant_take_ref (value);
              g_variant_builder_add (&builder, "{sv}", info->name, value);
              g_variant_unref (value);
            }
        }
    }
out:
  return g_variant_builder_end (&builder);
}

static gboolean _dbus_audio_sink_emit_changed (gpointer user_data);

static void
dbus_audio_sink_skeleton_dbus_interface_flush (GDBusInterfaceSkeleton *_skeleton)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (_skeleton);
  gboolean emit_changed = FALSE;

  g_mutex_lock (&skeleton->priv->lock);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    {
      g_source_destroy (skeleton->priv->changed_properties_idle_source);
      skeleton->priv->changed_properties_idle_source = NULL;
      emit_changed = TRUE;
    }
  g_mutex_unlock (&skeleton->priv->lock);

  if (emit_changed)
    _dbus_audio_sink_emit_changed (skeleton);
}

static void
_dbus_audio_sink_on_signal_change_mute (
    DBusAudioSink *object,
    gboolean arg_mute)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(b)",
                   arg_mute));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.AudioSink", "ChangeMute",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void
_dbus_audio_sink_on_signal_change_volume (
    DBusAudioSink *object,
    gdouble arg_volume)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);

  GList      *connections, *l;
  GVariant   *signal_variant;
  connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));

  signal_variant = g_variant_ref_sink (g_variant_new ("(d)",
                   arg_volume));
  for (l = connections; l != NULL; l = l->next)
    {
      GDBusConnection *connection = l->data;
      g_dbus_connection_emit_signal (connection,
        NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.sessiond.session1.AudioSink", "ChangeVolume",
        signal_variant, NULL);
    }
  g_variant_unref (signal_variant);
  g_list_free_full (connections, g_object_unref);
}

static void dbus_audio_sink_skeleton_iface_init (DBusAudioSinkIface *iface);
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (DBusAudioSinkSkeleton, dbus_audio_sink_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_ADD_PRIVATE (DBusAudioSinkSkeleton)
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_AUDIO_SINK, dbus_audio_sink_skeleton_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (DBusAudioSinkSkeleton, dbus_audio_sink_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_IMPLEMENT_INTERFACE (DBUS_TYPE_AUDIO_SINK, dbus_audio_sink_skeleton_iface_init))

#endif
static void
dbus_audio_sink_skeleton_finalize (GObject *object)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);
  guint n;
  for (n = 0; n < 4; n++)
    g_value_unset (&skeleton->priv->properties[n]);
  g_free (skeleton->priv->properties);
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    g_source_destroy (skeleton->priv->changed_properties_idle_source);
  g_main_context_unref (skeleton->priv->context);
  g_mutex_clear (&skeleton->priv->lock);
  G_OBJECT_CLASS (dbus_audio_sink_skeleton_parent_class)->finalize (object);
}

static void
dbus_audio_sink_skeleton_get_property (GObject      *object,
  guint         prop_id,
  GValue       *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);
  g_assert (prop_id != 0 && prop_id - 1 < 4);
  g_mutex_lock (&skeleton->priv->lock);
  g_value_copy (&skeleton->priv->properties[prop_id - 1], value);
  g_mutex_unlock (&skeleton->priv->lock);
}

static gboolean
_dbus_audio_sink_emit_changed (gpointer user_data)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (user_data);
  GList *l;
  GVariantBuilder builder;
  GVariantBuilder invalidated_builder;
  guint num_changes;

  g_mutex_lock (&skeleton->priv->lock);
  g_variant_builder_init (&builder, G_VARIANT_TYPE ("a{sv}"));
  g_variant_builder_init (&invalidated_builder, G_VARIANT_TYPE ("as"));
  for (l = skeleton->priv->changed_properties, num_changes = 0; l != NULL; l = l->next)
    {
      ChangedProperty *cp = l->data;
      GVariant *variant;
      const GValue *cur_value;

      cur_value = &skeleton->priv->properties[cp->prop_id - 1];
      if (!_g_value_equal (cur_value, &cp->orig_value))
        {
          variant = g_dbus_gvalue_to_gvariant (cur_value, G_VARIANT_TYPE (cp->info->parent_struct.signature));
          g_variant_builder_add (&builder, "{sv}", cp->info->parent_struct.name, variant);
          g_variant_unref (variant);
          num_changes++;
        }
    }
  if (num_changes > 0)
    {
      GList *connections, *ll;
      GVariant *signal_variant;
      signal_variant = g_variant_ref_sink (g_variant_new ("(sa{sv}as)", "org.sessiond.session1.AudioSink",
                                           &builder, &invalidated_builder));
      connections = g_dbus_interface_skeleton_get_connections (G_DBUS_INTERFACE_SKELETON (skeleton));
      for (ll = connections; ll != NULL; ll = ll->next)
        {
          GDBusConnection *connection = ll->data;

          g_dbus_connection_emit_signal (connection,
                                         NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)),
                                         "org.freedesktop.DBus.Properties",
                                         "PropertiesChanged",
                                         signal_variant,
                                         NULL);
        }
      g_variant_unref (signal_variant);
      g_list_free_full (connections, g_object_unref);
    }
  else
    {
      g_variant_builder_clear (&builder);
      g_variant_builder_clear (&invalidated_builder);
    }
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  skeleton->priv->changed_properties = NULL;
  skeleton->priv->changed_properties_idle_source = NULL;
  g_mutex_unlock (&skeleton->priv->lock);
  return FALSE;
}

static void
_dbus_audio_sink_schedule_emit_changed (DBusAudioSinkSkeleton *skeleton, const _ExtendedGDBusPropertyInfo *info, guint prop_id, const GValue *orig_value)
{
  ChangedProperty *cp;
  GList *l;
  cp = NULL;
  for (l = skeleton->priv->changed_properties; l != NULL; l = l->next)
    {
      ChangedProperty *i_cp = l->data;
      if (i_cp->info == info)
        {
          cp = i_cp;
          break;
        }
    }
  if (cp == NULL)
    {
      cp = g_new0 (ChangedProperty, 1);
      cp->prop_id = prop_id;
      cp->info = info;
      skeleton->priv->changed_properties = g_list_prepend (skeleton->priv->changed_properties, cp);
      g_value_init (&cp->orig_value, G_VALUE_TYPE (orig_value));
      g_value_copy (orig_value, &cp->orig_value);
    }
}

static void
dbus_audio_sink_skeleton_notify (GObject      *object,
  GParamSpec *pspec G_GNUC_UNUSED)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);
  g_mutex_lock (&skeleton->priv->lock);
  if (skeleton->priv->changed_properties != NULL &&
      skeleton->priv->changed_properties_idle_source == NULL)
    {
      skeleton->priv->changed_properties_idle_source = g_idle_source_new ();
      g_source_set_priority (skeleton->priv->changed_properties_idle_source, G_PRIORITY_DEFAULT);
      g_source_set_callback (skeleton->priv->changed_properties_idle_source, _dbus_audio_sink_emit_changed, g_object_ref (skeleton), (GDestroyNotify) g_object_unref);
      g_source_set_name (skeleton->priv->changed_properties_idle_source, "[generated] _dbus_audio_sink_emit_changed");
      g_source_attach (skeleton->priv->changed_properties_idle_source, skeleton->priv->context);
      g_source_unref (skeleton->priv->changed_properties_idle_source);
    }
  g_mutex_unlock (&skeleton->priv->lock);
}

static void
dbus_audio_sink_skeleton_set_property (GObject      *object,
  guint         prop_id,
  const GValue *value,
  GParamSpec   *pspec)
{
  const _ExtendedGDBusPropertyInfo *info;
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);
  g_assert (prop_id != 0 && prop_id - 1 < 4);
  info = (const _ExtendedGDBusPropertyInfo *) _dbus_audio_sink_property_info_pointers[prop_id - 1];
  g_mutex_lock (&skeleton->priv->lock);
  g_object_freeze_notify (object);
  if (!_g_value_equal (value, &skeleton->priv->properties[prop_id - 1]))
    {
      if (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)) != NULL &&
          info->emits_changed_signal)
        _dbus_audio_sink_schedule_emit_changed (skeleton, info, prop_id, &skeleton->priv->properties[prop_id - 1]);
      g_value_copy (value, &skeleton->priv->properties[prop_id - 1]);
      g_object_notify_by_pspec (object, pspec);
    }
  g_mutex_unlock (&skeleton->priv->lock);
  g_object_thaw_notify (object);
}

static void
dbus_audio_sink_skeleton_init (DBusAudioSinkSkeleton *skeleton)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  skeleton->priv = dbus_audio_sink_skeleton_get_instance_private (skeleton);
#else
  skeleton->priv = G_TYPE_INSTANCE_GET_PRIVATE (skeleton, DBUS_TYPE_AUDIO_SINK_SKELETON, DBusAudioSinkSkeletonPrivate);
#endif

  g_mutex_init (&skeleton->priv->lock);
  skeleton->priv->context = g_main_context_ref_thread_default ();
  skeleton->priv->properties = g_new0 (GValue, 4);
  g_value_init (&skeleton->priv->properties[0], G_TYPE_UINT);
  g_value_init (&skeleton->priv->properties[1], G_TYPE_STRING);
  g_value_init (&skeleton->priv->properties[2], G_TYPE_BOOLEAN);
  g_value_init (&skeleton->priv->properties[3], G_TYPE_DOUBLE);
}

static guint 
dbus_audio_sink_skeleton_get_id (DBusAudioSink *object)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);
  guint value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_uint (&(skeleton->priv->properties[0]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static const gchar *
dbus_audio_sink_skeleton_get_name (DBusAudioSink *object)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);
  const gchar *value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_string (&(skeleton->priv->properties[1]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static gboolean 
dbus_audio_sink_skeleton_get_mute (DBusAudioSink *object)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);
  gboolean value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_boolean (&(skeleton->priv->properties[2]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static gdouble 
dbus_audio_sink_skeleton_get_volume (DBusAudioSink *object)
{
  DBusAudioSinkSkeleton *skeleton = DBUS_AUDIO_SINK_SKELETON (object);
  gdouble value;
  g_mutex_lock (&skeleton->priv->lock);
  value = g_value_get_double (&(skeleton->priv->properties[3]));
  g_mutex_unlock (&skeleton->priv->lock);
  return value;
}

static void
dbus_audio_sink_skeleton_class_init (DBusAudioSinkSkeletonClass *klass)
{
  GObjectClass *gobject_class;
  GDBusInterfaceSkeletonClass *skeleton_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize = dbus_audio_sink_skeleton_finalize;
  gobject_class->get_property = dbus_audio_sink_skeleton_get_property;
  gobject_class->set_property = dbus_audio_sink_skeleton_set_property;
  gobject_class->notify       = dbus_audio_sink_skeleton_notify;


  dbus_audio_sink_override_properties (gobject_class, 1);

  skeleton_class = G_DBUS_INTERFACE_SKELETON_CLASS (klass);
  skeleton_class->get_info = dbus_audio_sink_skeleton_dbus_interface_get_info;
  skeleton_class->get_properties = dbus_audio_sink_skeleton_dbus_interface_get_properties;
  skeleton_class->flush = dbus_audio_sink_skeleton_dbus_interface_flush;
  skeleton_class->get_vtable = dbus_audio_sink_skeleton_dbus_interface_get_vtable;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (DBusAudioSinkSkeletonPrivate));
#endif
}

static void
dbus_audio_sink_skeleton_iface_init (DBusAudioSinkIface *iface)
{
  iface->change_mute = _dbus_audio_sink_on_signal_change_mute;
  iface->change_volume = _dbus_audio_sink_on_signal_change_volume;
  iface->get_id = dbus_audio_sink_skeleton_get_id;
  iface->get_name = dbus_audio_sink_skeleton_get_name;
  iface->get_mute = dbus_audio_sink_skeleton_get_mute;
  iface->get_volume = dbus_audio_sink_skeleton_get_volume;
}

/**
 * dbus_audio_sink_skeleton_new:
 *
 * Creates a skeleton object for the D-Bus interface <link linkend="gdbus-interface-org-sessiond-session1-AudioSink.top_of_page">org.sessiond.session1.AudioSink</link>.
 *
 * Returns: (transfer full) (type DBusAudioSinkSkeleton): The skeleton object.
 */
DBusAudioSink *
dbus_audio_sink_skeleton_new (void)
{
  return DBUS_AUDIO_SINK (g_object_new (DBUS_TYPE_AUDIO_SINK_SKELETON, NULL));
}

